function [  meanCircCovGood,meanCircCovFake ] = computeCP( resGood,resFake,opts )

meanCircCovFake=NaN(size(resFake.trj,1)-1,size(resFake.trj,2));
meanCircCovGood=NaN(size(resGood.trj,1)-1,size(resGood.trj,2));

if(size(resFake.trj,1)>2)
    %% compute covariance profile
    % Encoder off
    
    matrixC=NaN(size(resFake.trj,1),size(resFake.trj,1));
    
    for sp=1:size(resFake.trj,2)
        tr=1;
        disp(['searching for best starting trajectories from position ',num2str(sp),'...']);
        for f=1:size(resFake.trj,1)-1
            for s=f+1:size(resFake.trj,1)
                cols=size(resFake.trj{f,sp}(1,:),2);
                xyCov=zeros(cols,2,2);
                for t=1:cols
                    c = cov([resFake.trj{f,sp}(1,t),resFake.trj{s,sp}(1,t)],[resFake.trj{f,sp}(2,t),resFake.trj{s,sp}(2,t)]);
                    xyCov(t,:,:) = c;
                end
                xcov=xyCov(:,1,1);
                xcov=xcov(xcov>0);
                ycov=xyCov(:,2,2);
                ycov=ycov(ycov>0);
                mxcov=mean(xcov);
                mycov=mean(ycov);
                tmpC=sqrt(mxcov^2+mycov^2);
                matrixC(f,s)=tmpC;
            end
        end
        
        [M,I] = min(matrixC(:));
        [I_row, I_col] = ind2sub(size(matrixC),I);
        meanCircCovFake(tr,sp)=M;
        firstSetX=[resFake.trj{I_row,sp}(1,:);resFake.trj{I_col,sp}(1,:)];
        firstSetY=[resFake.trj{I_row,sp}(2,:);resFake.trj{I_col,sp}(2,:)];
        tmpTrjFake=resFake.trj(:,sp);

        if(I_row>I_col)
            tmpTrjFake(I_row)=[];
            tmpTrjFake(I_col)=[];
        else
            tmpTrjFake(I_col)=[];
            tmpTrjFake(I_row)=[];
        end
        
        
        for tt=1:(size(tmpTrjFake,1))
            minC=Inf;
            idxC=1;
            for f=1:size(tmpTrjFake,1)
                cols=size(resFake.trj{f,sp}(1,:),2);
                xyCov=zeros(cols,2,2);
                for t=1:cols
                    c = cov([firstSetX(:,t);resFake.trj{s,sp}(1,t)],[firstSetY(:,t);resFake.trj{s,sp}(2,t)]);
                    xyCov(t,:,:) = c;
                end
                xcov=xyCov(:,1,1);
                xcov=xcov(xcov>0);
                ycov=xyCov(:,2,2);
                ycov=ycov(ycov>0);
                mxcov=mean(xcov);
                mycov=mean(ycov);
                tmpC=sqrt(mxcov^2+mycov^2);
                if(minC>tmpC)
                    minC=tmpC;
                    idxC=f;
                end
            end
            
            firstSetX=[firstSetX;  tmpTrjFake{idxC}(1,:)];
            firstSetY=[firstSetY; tmpTrjFake{idxC}(2,:)];
            tmpTrjFake(idxC)=[];
            tr=tr+1;
            meanCircCovFake(tr,sp)=minC;
            disp(['Encoder OFF computed trials = ',num2str(tr),'    starting position = ',num2str(sp)]);
        end
    end
    
    %Encoder on
    
    matrixC=NaN(size(resGood.trj,1),size(resGood.trj,1));
    
    for sp=1:size(resGood.trj,2)
        tr=1;
        
        disp(['searching for best starting trajectories from position ',num2str(sp),'...']);
        for f=1:size(resGood.trj,1)-1
            for s=f+1:size(resGood.trj,1)
                cols=size(resGood.trj{f,sp}(1,:),2);
                xyCov=zeros(cols,2,2);
                for t=1:cols
                    c = cov([resGood.trj{f,sp}(1,t),resGood.trj{s,sp}(1,t)],[resGood.trj{f,sp}(2,t),resGood.trj{s,sp}(2,t)]);
                    xyCov(t,:,:) = c;
                end
                xcov=xyCov(:,1,1);
                xcov=xcov(xcov>0);
                ycov=xyCov(:,2,2);
                ycov=ycov(ycov>0);
                mxcov=mean(xcov);
                mycov=mean(ycov);
                tmpC=sqrt(mxcov^2+mycov^2);
                matrixC(f,s)=tmpC;
            end
        end
        
        [M,I] = min(matrixC(:));
        [I_row, I_col] = ind2sub(size(matrixC),I);
        meanCircCovGood(tr,sp)=M;
        firstSetX=[resGood.trj{I_row,sp}(1,:);resGood.trj{I_col,sp}(1,:)];
        firstSetY=[resGood.trj{I_row,sp}(2,:);resGood.trj{I_col,sp}(2,:)];
        tmpTrjGood=resGood.trj(:,sp);
        
        if(I_row>I_col)
            tmpTrjGood(I_row)=[];
            tmpTrjGood(I_col)=[];
        else
            tmpTrjGood(I_col)=[];
            tmpTrjGood(I_row)=[];
        end
        
        
        for tt=1:(size(tmpTrjGood,1))
            minC=Inf;
            idxC=1;
            for f=1:size(tmpTrjGood,1)
                cols=size(resGood.trj{f,sp}(1,:),2);
                xyCov=zeros(cols,2,2);
                for t=1:cols
                    c = cov([firstSetX(:,t);resGood.trj{s,sp}(1,t)],[firstSetY(:,t);resGood.trj{s,sp}(2,t)]);
                    xyCov(t,:,:) = c;
                end
                xcov=xyCov(:,1,1);
                xcov=xcov(xcov>0);
                ycov=xyCov(:,2,2);
                ycov=ycov(ycov>0);
                mxcov=mean(xcov);
                mycov=mean(ycov);
                tmpC=sqrt(mxcov^2+mycov^2);
                if(minC>tmpC)
                    minC=tmpC;
                    idxC=f;
                end
            end
            
            firstSetX=[firstSetX;  tmpTrjGood{idxC}(1,:)];
            firstSetY=[firstSetY; tmpTrjGood{idxC}(2,:)];
            tmpTrjGood(idxC)=[];
            tr=tr+1;
            meanCircCovGood(tr,sp)=minC;
            disp(['Encoder ON computed trials = ',num2str(tr),'    starting position = ',num2str(sp)]);
        end
    end
    
    if(opts.plotAnalysis)
        %%plot routines
        MendCovGood=mean(squeeze(meanCircCovGood(end,:).*opts.scalingFactor));
        SendCovGood=std(squeeze(meanCircCovGood(end,:).*opts.scalingFactor))/sqrt(numel(meanCircCovGood));
        MendCovFake=mean(squeeze(meanCircCovFake(end,:).*opts.scalingFactor));
        SendCovFake=std(squeeze(meanCircCovFake(end,:).*opts.scalingFactor))/sqrt(numel(meanCircCovFake));
        
        figure,
        subplot(1,2,1),
        bar([MendCovFake MendCovGood ; 0 0 ]);
        hold on;
        errorbar([1.14 0.86],[MendCovGood MendCovFake],[SendCovGood SendCovFake],'r.');
        bar([MendCovFake MendCovGood ; 0 0 ]);
        legend({'Encoder off','Encoder on'});
        xlim([0.5 1.5]);
        ax=gca;
        ylabel('Mean wtv [cm]');
        ax.XTickLabel={' '};
        
        %compute mean steps
        MendStepGood=mean(mean(resGood.step))/(opts.T/opts.dt);
        SendStepGood=std(mean(resGood.step)/(opts.T/opts.dt))/sqrt(numel(resGood.step));
        
        MendStepFake=mean(mean(resFake.step))/(opts.T/opts.dt);
        SendStepFake=std(mean(resFake.step)/(opts.T/opts.dt))/sqrt(numel(resFake.step));
        
        subplot(1,2,2)
        bar([MendStepFake MendStepGood ; 0 0 ]);
        hold on;
        errorbar([1.14 0.86],[ MendStepGood MendStepFake],[ SendStepGood SendStepFake],'r.');
        bar([MendStepFake MendStepGood ; 0 0 ]);
        legend({'Encoder off','Encoder on'});
        xlim([0.5 1.5]);
        ax=gca;
        ylabel('Number of steps');
        ax.XTickLabel={' '};
    end
else
    
    disp('Not enogh trajectories to perform analysis. Please set opts.numTrials bigger or equal to 3');
    
    
end

