function [result] = computeCovarainceAndMean(XYmatrix,opts)

nMaxStep = max(max(cellfun('length',XYmatrix)));

[nTrial, nPoint] = size(XYmatrix);
nConv = 0;
nStep = [];
trajMean = cell(1,nPoint);
for pp = 1:nPoint
    x = zeros(nTrial,nMaxStep);
    y = zeros(nTrial,nMaxStep);
    for tt = 1:nTrial
        tmp = XYmatrix{tt,pp};
        if(opts.plotBMIresult)
            figure(opts.fig1)
            plot(tmp(1,:),tmp(2,:),['-', opts.color(mod(pp,6)+1)]);
            hold on;
        end
        
        x(tt,1:numel(tmp(1,:))) = tmp(1,:);
        y(tt,1:numel(tmp(2,:))) = tmp(2,:);
        if(opts.stopOnTarget)
            value = tmp(1,end)^2 + tmp(2',end)^2;
            if value <= opts.radius^2
                nConv = nConv+1;
                nStep = [nStep size(tmp,2)];
                plot(tmp(1,end),tmp(2,end),['*', opts.color(mod(pp,6)+1)]);
            end
        else
            plot(tmp(1,end),tmp(2,end),['*', opts.color(mod(pp,6)+1)]);
        end
    end
   
    [xmean,ymean,xyCov] = plotmeanmovement(x,y,opts);
    trajMean{pp} = [xmean;ymean];
    xcov=xyCov(2:end,1,1);
    xcov=xcov(xcov>0);
    ycov=xyCov(2:end,2,2);
    ycov=ycov(ycov>0);
    mxcov(pp)=mean(xcov);
    mycov(pp)=mean(ycov);
    mxstd(pp)=std(xcov);
    mystd(pp)=std(ycov);
  
end

convRate = (nConv*100)/(nTrial*nPoint);
result.xCov=mxcov;
result.yCov=mycov;
result.xCovStd=mxstd;
result.yCovStd=mystd;
result.convRate=convRate;
result.step=mean(nStep)/(opts.T/opts.dt);
result.stepStd=std(nStep)/(opts.T/opts.dt);

figure(opts.fig1);
axis(opts.fieldLimits);
title('Whole Trajectories');
ax=gca;
xl=cellfun(@(x)str2double(x), ax.XTickLabel)*opts.scalingFactor;
set(ax,'XTickLabel',num2cell(xl));
yl=cellfun(@(x)str2double(x), ax.YTickLabel)*opts.scalingFactor;
set(ax,'YTickLabel',num2cell(yl));
xlabel('x [cm]');
ylabel('y [cm]');

figure(opts.fig2);
axis(opts.fieldLimits);
title('Mean trajectory and Covariance Area');
ax=gca;
xl=cellfun(@(x)str2double(x), ax.XTickLabel)*opts.scalingFactor;
set(ax,'XTickLabel',num2cell(xl));
yl=cellfun(@(x)str2double(x), ax.YTickLabel)*opts.scalingFactor;
set(ax,'YTickLabel',num2cell(yl));
xlabel('x [cm]');
ylabel('y [cm]');
