function [ dirVecGood,perVecGood,dirVecFake,perVecFake ] = computeFD( resGood,resFake,opts )

%force computation

%good set
[maxIter,numInit]=size(resGood.force);
dirVecGood=cell(maxIter,numInit);
perVecGood=cell(maxIter,numInit);
for i=1:maxIter
    for j=1:numInit
        for k=1:size(resGood.force{i,j},2)
            beta=atan2d(resGood.force{i,j}(2,k),resGood.force{i,j}(1,k));
            if(beta<0)
                beta=beta+360;
            end
            gamma=atan2d(resGood.trj{i,j}(2,k*(opts.T/opts.dt)),resGood.trj{i,j}(1,k*(opts.T/opts.dt)));
            if(gamma<0)
                gamma=gamma+360;
            end
            gamma=mod(gamma+180,360);
            
            if(beta<=gamma)
                alpha=gamma-beta;
                perVecGood{i,j}(k)=-sqrt(resGood.force{i,j}(2,k)^2+resGood.force{i,j}(1,k)^2)*sind(alpha);
            else
                alpha=beta-gamma;
                perVecGood{i,j}(k)=sqrt(resGood.force{i,j}(2,k)^2+resGood.force{i,j}(1,k)^2)*sind(alpha);
            end
            
            dirVecGood{i,j}(k)=sqrt(resGood.force{i,j}(2,k)^2+resGood.force{i,j}(1,k)^2)*cosd(alpha);
            
            
        end
    end
end
%fake set
[maxIter,numInit]=size(resFake.force);
dirVecFake=cell(maxIter,numInit);
perVecFake=cell(maxIter,numInit);
for i=1:maxIter
    for j=1:numInit
        for k=1:size(resFake.force{i,j},2)
            beta=atan2d(resFake.force{i,j}(2,k),resFake.force{i,j}(1,k));
            if(beta<0)
                beta=beta+360;
            end
            gamma=atan2d(resFake.trj{i,j}(2,k*(opts.T/opts.dt)),resFake.trj{i,j}(1,k*(opts.T/opts.dt)));
            if(gamma<0)
                gamma=gamma+360;
            end
            gamma=mod(gamma+180,360);
            
            if(beta<=gamma)
                alpha=gamma-beta;
                perVecFake{i,j}(k)=-sqrt(resFake.force{i,j}(2,k)^2+resFake.force{i,j}(1,k)^2)*sind(alpha);
            else
                alpha=beta-gamma;
                perVecFake{i,j}(k)=sqrt(resFake.force{i,j}(2,k)^2+resFake.force{i,j}(1,k)^2)*sind(alpha);
            end
            
            dirVecFake{i,j}(k)=sqrt(resFake.force{i,j}(2,k)^2+resFake.force{i,j}(1,k)^2)*cosd(alpha);
            
            
        end
    end
end

%% PLOT ROUTINES
if(opts.plotAnalysis)
    %plot force results
    [maxIter,numInit]=size(resGood.force);
    k=0;
    for i=1:maxIter
        for j=1:numInit
            k=k+1;
            tmpDirGood(k)=mean((dirVecGood{i,j}));
            tmpDirFake(k)=mean((dirVecFake{i,j}));
        end
    end
    MdirGood=mean(tmpDirGood.*opts.scalingFactor);
    SdirGood=std(tmpDirGood.*opts.scalingFactor)/sqrt(numel(tmpDirGood));
    MdirFake=mean(tmpDirFake.*opts.scalingFactor);
    SdirFake=std(tmpDirFake.*opts.scalingFactor)/sqrt(numel(tmpDirFake));
    
    
    %plot
    figure,
    bar([MdirFake MdirGood; 0 0 ]);
    hold on;
    errorbar([0.86 1.14],[MdirFake MdirGood ],[SdirFake SdirGood ],'r.');
    legend({'Encoder off','Encoder on'});
    bar([MdirFake MdirGood; 0 0 ]);
    xlim([0.5 1.5]);
    ax=gca;
    ax.XTickLabel={' '};
    ylabel('Mean DT component magnitude');
end



end

