function [  ] = frontiersAnalysis( datasetName )


%% Analysis Encoder ON and Encoder OFF with both target region and 100 steps stopping criteria

%load data
load(datasetName);

%dataset specs
opts=resultBMI.opts;
opts.plotAnalysis=true;
opts.plotBMIresult=true;
opts.stopOnTarget=true;
opts.color=['c','m','k','b','y','g'];
opts.nStim=size(resultBMI.testForcesBMI,2);
opts.nTrialTest = size(resultBMI.testForcesBMI,1);

%prepare dataset for the following analysis
resOFF=preapareDatasetAnalysis( resultBMI.trjOFF,resultBMI.forceOFF,opts.radius,opts.T,opts.dt );
resON=preapareDatasetAnalysis( resultBMI.trjON,resultBMI.forceON,opts.radius,opts.T,opts.dt );

%compute covariance and mean of the reajectories with encoder ON and plot
%results
opts.fig1=104;
opts.fig2=105;
computeCovarainceAndMean(resultBMI.trjON,opts);
figure(opts.fig1);
axis(opts.fieldLimits);
title('Whole Trajectories BMI');
figure(opts.fig2);
title('Mean trajectory and Covariance Area BMI');

%compute covariance and mean of the reajectories with encoder OFF and plot
%results
opts.fig1=106;
opts.fig2=107;
computeCovarainceAndMean(resultBMI.trjOFF,opts);
figure(opts.fig1);
axis(opts.fieldLimits);
title('Whole Trajectories BMI');
figure(opts.fig2);
title('Mean trajectory and Covariance Area BMI');

%plot rose plot of the forces produced during the testing phase
rosePlots( resultBMI.testForcesBMI, resultBMI.recForce,'BMI force test set' );
 
%compute the wtv factor and plot results
computeCP( resON,resOFF,opts ); %this analysis requires almost 1 hour computational time, so comment this line if you wanna make the analysis faster

%compute the DT force component and plot results 
computeFD( resON,resOFF,opts );


end

