function plot2std(c,m,opts)
%
%  Plot the standard deviation in 2D (square root of the covariance matrix)
%

[U A V] =svd(c);
A1 = A^(0.5);
st=U*A1*V';

for i=1:50
    ux=cos(i*2.0*pi/50);
    uy=sin(i*2.0*pi/50);
    px(i)= m(1)+ st(1,1)*ux+st(1,2)*uy;
    py(i)= m(2)+ st(2,1)*ux+st(2,2)*uy;
end

if(opts.stopOnTarget)
    fill(px(px.^2+py.^2>opts.radius^2),py(px.^2+py.^2>opts.radius^2),[.8 .8 1],'EdgeColor', 'none');
else
    fill(px,py,[.8 .8 1],'EdgeColor', 'none');
end