function [ result ] = preapareDatasetAnalysis( XYmatrix,forceResult, radius, T, dt )
%COMPUTETRJANDMIN Summary of this function goes here
%   Detailed explanation goes here
[nTrial, nPoint] = size(XYmatrix);
nMaxStep = max(max(cellfun('length',XYmatrix)));

result.trj= cell(nTrial,nPoint);
result.convRate = zeros(nPoint,1);
result.step = nMaxStep*ones(nTrial,nPoint);

for pp = 1:nPoint
    for tt = 1:nTrial
        tmp = XYmatrix{tt,pp};
        result.trj{tt,pp} = zeros(4,nMaxStep);
        targetReached=false;
        for ss = 1:size(tmp,2)
            value = sqrt(tmp(1,ss)^2 + tmp(2,ss)^2);
            if ((value <= radius) && (targetReached==false))
                result.convRate(pp)=result.convRate(pp)+1;
                result.step(tt,pp)=ss;
                targetReached=true;
                result.trj{tt,pp}(1,ss)=tmp(1,ss);
                result.trj{tt,pp}(2,ss)=tmp(2,ss);
                result.force{tt,pp}(1,1:floor(ss/(T/dt)))=forceResult{tt,pp}(1:floor(ss/(T/dt)),1);
                result.force{tt,pp}(2,1:floor(ss/(T/dt)))=forceResult{tt,pp}(1:floor(ss/(T/dt)),2);
            end
            if(targetReached==false)
                result.trj{tt,pp}(1,ss)=tmp(1,ss);
                result.trj{tt,pp}(2,ss)=tmp(2,ss);
            end
        end
        if(targetReached==false)
            result.force{tt,pp}(1,:)=forceResult{tt,pp}(:,1);
            result.force{tt,pp}(2,:)=forceResult{tt,pp}(:,2);
        end
    end
    result.convRate(pp)=result.convRate(pp)*100/nTrial;
end



end

