function rosePlot( recordedForces, calibrationForces, strTitle )

figure('Name',strTitle),


clr1 = ['c','c','c','c'];
clr2 = ['c','b','g','r'];
location = [2,3,1,4];

nTrials = size(recordedForces,1)*ones(1,4);
nStims  = size(recordedForces,2);
nCol    = ceil(sqrt(nStims));
nRow    = ceil(nStims/nCol);

Fmax    = max(abs(recordedForces(:)));


x  = [0 Fmax 0 -Fmax];
y  = [Fmax 0 -Fmax 0];


for ss = 1:nStims
    
    hs(ss)=subplot(2,2,ss);
    tmp    = squeeze(recordedForces(1:nTrials(location(ss)),location(ss),:));
    box off;
    axis off;
    
    
    compass(x,y,'w');
    hold on
    compass(tmp(:,1),tmp(:,2),'k');
    
   
    q = arrw([0 0]',[calibrationForces(location(ss),1), calibrationForces(location(ss),2)]');
  
    plot(q(1,:), q(2,:), clr2(ss),'linewidth',3);
    
end

end


