#include<iostream>
#include<stdio.h> 
#include<string> 
#include<stdlib.h> 
#include<unistd.h>
#include<arpa/inet.h>
#include <math.h>
#include<sys/socket.h>
#include <vector>
#include <errno.h>
#include <sys/ioctl.h>
#include <unistd.h>
#include <fcntl.h>
#include <errno.h>
#include <string.h>

#include "boost/multi_array.hpp"
#include "UDPlib.h"
#include "BMIlib.h"





using namespace std;
using namespace boost::multi_array_types;
using namespace boost::numeric::ublas;

///////////////////Class Definition////////////////////////////////////

dataset::dataset()
{
  bins=0;
  trials=0;
  channels=0;
  stim=0;
  fileName.assign("noname.mat");
}

dataset::dataset(int b, int t,int c,int s)
{
  
  bins=b;
  trials=t;
  channels=c;
  stim=s;
  fileName.assign("noname.mat");
  data.resize(extents[b][t][c][s]);
}

dataset::dataset(int b, int t,int c,int s,string n)
{
  
  bins=b;
  trials=t;
  channels=c;
  stim=s;
  fileName=n;
  data.resize(extents[b][t][c][s]);
}

void dataset::changeSize(int b, int t, int c, int s)
{
  bins=b;
  trials=t;
  channels=c;
  stim=s;
  data.resize(extents[b][t][c][s]);
}


dataset::~dataset()
{

}

brainNode::brainNode()
{
  output_neuron=0;
  output_synapse=0;
  weight=0;

}

brainNode::brainNode(int n, int s)
{
  output_neuron=n;
  output_synapse=s;
  weight=0;

}

brainNode::brainNode(int n, int s, float w)
{
  output_neuron=n;
  output_synapse=s;
  weight=w/1000;

}

brainNode::~brainNode()
{

}

forceField::forceField()
{
  rangeX[0]=0;
  rangeX[1]=0;
  rangeY[0]=0;
  rangeY[1]=0;
  zero[0]=0;
  zero[1]=0;
}

forceField::forceField(int w[2], int h[2], double z[2], double xxstiff,double yystiff,sensoryField SF)
{
  std::vector<std::vector<double> >::iterator it;
  std::vector<double>::iterator its;
  
  rangeX[0]=w[0];
  rangeX[1]=w[1];
  rangeY[0]=h[0];
  rangeY[1]=h[1];
  zero[0]=z[0];
  zero[1]=z[1];
  stiffness.resize(2,2);
  stiffness(0,0)=xxstiff;
  stiffness(1,1)=yystiff;
  meanForce.resize(SF.regions);
  
  //da modificare con for ricorsivo/////////////////////////////////////
  int stepXR=(-zero[0]+rangeX[1])/(SF.regions/2);
  int stepXL=(-rangeX[0]+zero[0])/(SF.regions/2);
  int stepYU=(-zero[1]+rangeY[1])/(SF.regions/2);
  int stepYD=(-rangeY[0]+zero[1])/(SF.regions/2);
  
  
  it=meanForce.begin();
  it->resize(2);
  computeForce(zero[0]+stepXR,zero[1]-stepYD,&meanForce[0]);
  it++;
  
  it->resize(2);
  computeForce(zero[0]-stepXL,zero[1]-stepYD,&meanForce[1]);
  it++;
  
  it->resize(2);
  computeForce(zero[0]-stepXL,zero[1]+stepYU,&meanForce[2]);
  it++;
  
  it->resize(2);
  computeForce(zero[0]+stepXR,zero[1]+stepYU,&meanForce[3]);
  
//   int index=0;
//   for(it=meanForce.begin();it != meanForce.end();++it)
//   {
//     cout<<"region "<<index++<<endl;
//     for(its=it->begin();its != it->end();++its)
//     {
//       cout<<*its<<" ";
//     }
//     cout<<endl;
//   }
  ///////////////////////////////////////////////////
}

forceField::~forceField()
{

}

void forceField::computeForce(double x, double y, std::vector<double> *F)
{
  F->operator[](0)= -stiffness(0,0)*(x-zero[0]) -stiffness(0,1)*(y-zero[1]); 
  F->operator[](1)= -stiffness(1,0)*(x-zero[0]) -stiffness(1,1)*(y-zero[1]);
}

sensoryField::sensoryField()
{
  rangeX[0]=0;
  rangeX[1]=0;
  rangeY[0]=0;
  rangeY[1]=0;
  regions=0;
  zero[0]=0;
  zero[1]=0;
  resolution=0;

}

sensoryField::sensoryField(int* w, int* h, double* z, int reg, int res)
{
  
  rangeX[0]=w[0];
  rangeX[1]=w[1];
  rangeY[0]=h[0];
  rangeY[1]=h[1];
  zero[0]=z[0];
  zero[1]=z[1];
  regions=reg;
  resolution=res;
  
  //subdivide map in 'r' equal contiguous regions
  //compute number of rows and columns at a given resolution
  int cols=(-rangeX[0]+rangeX[1]+1)*resolution; //y
  int rows=(-rangeY[0]+rangeY[1]+1)*resolution; //x
  //create sensory map
  map.resize(rows,cols);
//   cout<<"rows: "<<rows<<" cols: "<<cols<<endl;
  //compute the angle range belonging each region
  double thetaRange = 360/regions; 
  //compute zero position in matrix position
  int zeroMatrix[2] = {round((-zero[1]*resolution)+rows/2),round((zero[0]*resolution)+cols/2)}; //rows,cols
//   cout<<"zero:"<<zeroMatrix[0]<<","<<zeroMatrix[1]<<endl;
  //check bounds
  if(zeroMatrix[0]<0 || zeroMatrix[0]>=rows || zeroMatrix[1]<0 || zeroMatrix[1]>=cols)
  {
    cout<<"Fatal error! Zero out of bounds."<<endl;
    exit(-1);
  }
  //fill the sensory map accordingly
  for (int i=0;i<rows;i++)
  {
    for (int j=0;j<cols;j++)
    { 
	map(i,j)=floor((atan2(i-zeroMatrix[0],j-zeroMatrix[1])* 180 / PI) /thetaRange); //if point is in the (0,180)° range
      if(map(i,j)<0) 
	map(i,j)=floor((360+(atan2(i-zeroMatrix[0],j-zeroMatrix[1])* 180 / PI)) /thetaRange);//if point is in the (180,360)° range
    }
  }
}

sensoryField::~sensoryField()
{

}

int sensoryField::whichRegion(double x, double y) 
{
  int colMatrix = round((x*resolution)+map.size1()/2); //x
  int rowMatrix =round((-y*resolution)+map.size2()/2); //y
  
//    cout <<"point requested is in matrix position:"<<rowMatrix<<","<<colMatrix<<endl;
  //check bounds
  if(rowMatrix<0 || rowMatrix>=map.size1()|| colMatrix<0 || colMatrix>=map.size2())
  {
    cout<<"Invalid request! Point out of bounds."<<endl;
    return -1;
  }
  else
  {
    return map(rowMatrix,colMatrix);
  }
  
}

dynamicParam::dynamicParam()
{

}

dynamicParam::dynamicParam(double xxmass,double yymass,double xxdamp,double yydamp, int* w,int* h,double* z,double rad, int rT, int tT)
{
  mass.resize(2,2);
  damping.resize(2,2);
  mass(0,0)=xxmass;
  mass(1,1)=yymass;
  damping(0,0)=xxdamp;
  damping(1,1)=yydamp;
  rangeX[0]=w[0];
  rangeX[1]=w[1];
  rangeY[0]=h[0];
  rangeY[1]=h[1];
  minField[0]=z[0];
  minField[1]=z[1];
  radius=rad;
  deltaTime=rT;
  interTime=tT;
    
}


dynamicParam::~dynamicParam()
{

}


motorHandle::motorHandle()
{
  h_min_duty=H_MIN_DUTY;
  h_max_duty=H_MAX_DUTY;
  v_min_duty=V_MIN_DUTY;
  v_max_duty=V_MAX_DUTY;
  step_duty=STEP_DUTY;
  h_max_step=floor((double)(h_max_duty-h_min_duty)/(double)step_duty);
  v_max_step=floor((double)(v_max_duty-v_min_duty)/(double)step_duty);
  h_gain=1;
  v_gain=1;
  curr_duty[0]=h_max_duty;
  curr_duty[1]=v_max_duty;
  rangeX[0]=0;
  rangeX[1]=0;
  rangeY[0]=0;
  rangeY[1]=0;
  mot_file=-1;
}

motorHandle::motorHandle(int* w,int* h)
{
  h_min_duty=H_MIN_DUTY;
  h_max_duty=H_MAX_DUTY;
  v_min_duty=V_MIN_DUTY;
  v_max_duty=V_MAX_DUTY;
  step_duty=STEP_DUTY;
  rangeX[0]=w[0];
  rangeX[1]=w[1];
  rangeY[0]=h[0];
  rangeY[1]=h[1];
  h_max_step=floor((double)(h_max_duty-h_min_duty)/step_duty);
  v_max_step=floor((double)(v_max_duty-v_min_duty)/step_duty);
  h_gain=(double)h_max_step/(double)(abs(rangeX[1]-rangeX[0]));
  v_gain=(double)v_max_step/(double)(abs(rangeY[1]-rangeY[0]));
  curr_duty[0]=h_max_duty;
  curr_duty[1]=v_max_duty;
  mot_file=-1;
}

motorHandle::~motorHandle()
{

}

void motorHandle::pos2duty(std::vector< double > position)
{
  double motorX,motorY;

  motorX=position[0]-(double)rangeX[0];
  motorY=position[1]-(double)rangeY[0];
//   cout<<"MotorX: "<<motorX<<"; MotorY: "<<motorY<<endl;
  curr_duty[0]=((double)h_min_duty + (motorX*h_gain*step_duty))*SCALE_RANGE_MOTOR;
  curr_duty[1]=((double)v_min_duty + (motorY*v_gain*step_duty))*SCALE_RANGE_MOTOR;
//   cout<<"h_gain: "<<h_gain<<"; v_gain: "<<v_gain<<endl;
}

//////////////////////////////Other Function////////////////////////////////////////////////////////////////////////


void initMotor(motorHandle *MH)
{
  MH->mot_file=open(MOTOR_ADDR, O_RDWR);
  if (MH->mot_file<0) 
  {
    printf("Error in opening %s\n", MOTOR_ADDR);
    exit(1);
  }
  else
  {
      // Set 20ms of period
    ioctl(MH->mot_file, PWM_PERIOD_WRITE, PERIOD);
    // Set PWM min limit
    ioctl(MH->mot_file, PWM_MIN_H, H_MIN_DUTY);
    // Set PWM max limit
    ioctl(MH->mot_file, PWM_MAX_H, H_MAX_DUTY);
    // Set PWM min limit
    ioctl(MH->mot_file, PWM_MIN_V, V_MIN_DUTY);
    // Set PWM max limit
    ioctl(MH->mot_file, PWM_MAX_V, V_MAX_DUTY);
    // Write default pwm values for both motor
    write(MH->mot_file, MH->curr_duty, sizeof(int)*NUMMOTORS);
  
    // Enable motor 0
    ioctl(MH->mot_file, PWM_ENABLE, MOTOR0);
    // Enable motor 1
    ioctl(MH->mot_file, PWM_ENABLE, MOTOR1);
    cout<<"Motor Switched ON!"<<endl;
  }    
}

void moveMotor(std::vector< double > position,motorHandle MH)
{
  MH.pos2duty(position);
  write(MH.mot_file, MH.curr_duty, sizeof(int)*NUMMOTORS);
  cout<<"Position ["<<position[0]<<","<<position[1]<<"] -> Duty Cycle ["<<MH.curr_duty[0]/SCALE_RANGE_MOTOR<<","<<MH.curr_duty[1]/SCALE_RANGE_MOTOR<<"]."<<endl;
}

void stopMotor(motorHandle MH)
{
  close(MH.mot_file);
  cout<<"Motor  Switched OFF!"<<endl;
}

void calibrateMotor(motorHandle MH)
{
  bool endCal=false;
  int resp;
  while(endCal==false)
  {
    cout<<"Insert horizontal duty cycle "<<endl;
    cin>>MH.curr_duty[0];
    cout<<"Insert vertical duty cycle "<<endl;
    cin>>MH.curr_duty[1];
    write(MH.mot_file, MH.curr_duty, sizeof(int)*NUMMOTORS);
    cout<<"Duty Cycle ["<<MH.curr_duty[0]<<","<<MH.curr_duty[1]<<"]."<<endl;   
    
    cout<<"Are you satisfied from the actual calibration? [1=yes, 0=no]"<<endl;
    scanf("%d",&resp);
    if(resp==1) endCal=true;
  }
}

void importDatasetSize(int s, sockaddr_in si_me, sockaddr_in si_other,int* bins,int* trials,int* channels,int* stim)
{
  string memory;
  string OK ("ok");
  
  receiveUDPString( s,si_me,si_other,&memory);
  *bins=atoi(memory.c_str());
  printf("Bins:\n%d\n",*bins);
  if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
  
  receiveUDPString( s,si_me,si_other,&memory);
  *trials=atoi(memory.c_str());
  printf("Trials:\n%d\n",*trials);
  if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
  
  
  receiveUDPString( s,si_me,si_other,&memory);
  *channels=atoi(memory.c_str());
  printf("Channels:\n%d\n",*channels);
  if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
  
  receiveUDPString( s,si_me,si_other,&memory);
  *stim=atoi(memory.c_str());
  printf("Stimulations:\n%d\n",*stim);
  if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
}

void importDataset(int s, sockaddr_in si_me, sockaddr_in si_other, dataset* bmiData)
{
  idx4D i,j,k;
  bool flag;
  string memory;
  string OK ("ok");
  FILE *dataOut;
  
  //////////////////////receive data////////////////////////
  for(i=0;i<bmiData->trials;i++)
  {
    for(j=0;j<bmiData->channels;j++)
    {
      for(k=0;k<bmiData->stim;k++)
      {
	receiveUDPString(s,si_me,si_other,&memory);
	StringShortTo4DMatrix(memory, bmiData, i,  j,  k);
	if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
      }
    }
  }
 
 //printout importing results
  cout <<"Dataset '"<< bmiData->fileName << "' loaded! (";
  cout << bmiData->data.shape()[0] << "x" << bmiData->data.shape()[1] << "x" << bmiData->data.shape()[2] << "x" << bmiData->data.shape()[3];
  cout <<  " : " << bmiData->data.num_elements()/1000*sizeof(short) <<" KBytes)."<<'\n'; 
  
  //save data
  cout<<"Locally saving data..."<<endl;
  dataOut=fopen("DataOut.txt","w");
  fprintf(dataOut,"%d\n",bmiData->trials);
  fprintf(dataOut,"%d\n",bmiData->channels);
  fprintf(dataOut,"%d\n",bmiData->stim);
  fprintf(dataOut,"%d\n",bmiData->bins);
  fflush(dataOut);
  for(i=0;i<bmiData->trials;i++)
  {
    for(j=0;j<bmiData->channels;j++)
    {
      for(k=0;k<bmiData->stim;k++)
      {
	for(int l=0;l<bmiData->bins;l++)
	{
	  fprintf(dataOut,"%d\n",bmiData->data[l][i][j][k]);
	  fflush(dataOut);
	}
      }
    }
  }
  
}

int loadData(dataset* bmiData)
{
  FILE *dataOut;
  
  //read data
  dataOut=fopen("DataOut.txt","r");
  
  fscanf(dataOut,"%d",&bmiData->trials);
  fscanf(dataOut,"%d",&bmiData->channels);
  fscanf(dataOut,"%d",&bmiData->stim);
  fscanf(dataOut,"%d",&bmiData->bins);

//   cout<<"Dataset dimension: "<<bmiData->bins<<"x"<<bmiData->trials<<"x"<<bmiData->channels<<"x"<<bmiData->stim<<endl;
//   bmiData->fileName.assign(name);
  bmiData->data.resize(extents[bmiData->bins][bmiData->trials][bmiData->channels][bmiData->stim]);
  cout<<"Dataset dimension: "<<bmiData->data.shape()[0]<<"x"<<bmiData->data.shape()[1]<<"x"<<bmiData->data.shape()[2]<<"x"<<bmiData->data.shape()[3]<<endl;
  
  for(int i=0;i<bmiData->trials;i++)
  {
    for(int j=0;j<bmiData->channels;j++)
    {
      for(int k=0;k<bmiData->stim;k++)
      {
	for(int l=0;l<bmiData->bins;l++)
	{
	  fscanf(dataOut,"%hd",&bmiData->data[l][i][j][k]);
// 	  cout<<"data"<<bmiData->data[l][i][j][k];
	}
      }
    }
  }
  return 0;
}


void importDataset2(int s, sockaddr_in si_me, sockaddr_in si_other, dataset* bmiDataTrain , dataset* bmiDataTest)
{
  
  int i,j,k,counter=0;
  bool flag;
  string memory;
  string OK ("ok");

  //////////////////////receive train data////////////////////////
  for(i=0;i<bmiDataTrain->trials;i++)
  {
    for(j=0;j<bmiDataTrain->channels;j++)
    {
      for(k=0;k<bmiDataTrain->stim;k++)
      {
	counter++;
	receiveUDPString(s,si_me,si_other,&memory);
	StringTo4DMatrix(memory, bmiDataTrain, i,  j,  k);
	if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
	printf("Download train set %d%%\n", counter*100/(bmiDataTrain->trials*bmiDataTrain->channels*bmiDataTrain->stim) );
      }
    }
  }
 
  //////////////////////receive test data////////////////////////
  counter=0;
  for(i=0;i<bmiDataTest->trials;i++)
  {
    for(j=0;j<bmiDataTest->channels;j++)
    {
      for(k=0;k<bmiDataTest->stim;k++)
      {
	counter++;
	receiveUDPString(s,si_me,si_other,&memory);
	StringTo4DMatrix(memory, bmiDataTest, i,  j,  k);
	if(SAFE_TRANSMISSION) sendUDPString( s,si_other,&OK);
	printf("Download test set %d%%\n",counter*100/(bmiDataTest->trials*bmiDataTest->channels*bmiDataTest->stim) );
      }
    }
  }
 
 //printout importing results
  cout <<"Dataset '"<< bmiDataTrain->fileName << "' loaded! (";
  cout << bmiDataTrain->data.shape()[0] << "x" << bmiDataTrain->data.shape()[1] << "x" << bmiDataTrain->data.shape()[2] << "x" << bmiDataTrain->data.shape()[3];
  cout <<  " : " << bmiDataTrain->data.num_elements()/1000*sizeof(short) <<" KBytes)."<<'\n'; 
  
  cout <<"Dataset '"<< bmiDataTest->fileName << "' loaded! (";
  cout << bmiDataTest->data.shape()[0] << "x" << bmiDataTest->data.shape()[1] << "x" << bmiDataTest->data.shape()[2] << "x" << bmiDataTest->data.shape()[3];
  cout <<  " : " << bmiDataTest->data.num_elements()/1000*sizeof(short) <<" KBytes)."<<'\n'; 
  
//   //write down dataset
// 
//   #define data1 "inputtrain1.txt"
//   #define data2 "inputtrain2.txt"
//   #define data3 "inputtrain3.txt"
//   #define data4 "inputtrain4.txt"
//   #define data5 "inputtest1.txt"
//   #define data6 "inputtest2.txt"
//   #define data7 "inputtest3.txt"
//   #define data8 "inputtest4.txt"
//   
//   FILE *inputdata1,*inputdata2,*inputdata3,*inputdata4,*inputdata5,*inputdata6,*inputdata7,*inputdata8;
//   
//   inputdata1=fopen(data1,"w");
//   inputdata2=fopen(data2,"w");
//   inputdata3=fopen(data3,"w");
//   inputdata4=fopen(data4,"w");
//   inputdata5=fopen(data5,"w");
//   inputdata6=fopen(data6,"w");
//   inputdata7=fopen(data7,"w");
//   inputdata8=fopen(data8,"w");
//   
//   
//   for(int j=0;j<bmiDataTrain->channels;j++)
//   {
//     for(int k=0;k<bmiDataTrain->bins;k++)
//     {
//       for(int l=0;l<bmiDataTrain->trials;l++)
//       {
// 	fprintf(inputdata1,"%d\n",bmiDataTrain->data[k][l][j][0]);
// 	fflush(inputdata1);
//       }
//     }
//   }
//   for(int j=0;j<bmiDataTrain->channels;j++)
//   {
//     for(int k=0;k<bmiDataTrain->bins;k++)
//     {
//       for(int l=0;l<bmiDataTrain->trials;l++)
//       {
// 	fprintf(inputdata2,"%d\n",bmiDataTrain->data[k][l][j][1]);
// 	fflush(inputdata2);
//       }
//     }
//   }
//   for(int j=0;j<bmiDataTrain->channels;j++)
//   {
//     for(int k=0;k<bmiDataTrain->bins;k++)
//     {
//       for(int l=0;l<bmiDataTrain->trials;l++)
//       {
// 	fprintf(inputdata3,"%d\n",bmiDataTrain->data[k][l][j][2]);
// 	fflush(inputdata3);
//       }
//     }
//   }
//   for(int j=0;j<bmiDataTrain->channels;j++)
//   {
//     for(int k=0;k<bmiDataTrain->bins;k++)
//     {
//       for(int l=0;l<bmiDataTrain->trials;l++)
//       {
// 	fprintf(inputdata4,"%d\n",bmiDataTrain->data[k][l][j][3]);
// 	fflush(inputdata4);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->channels;j++)
//   {
//     for(int k=0;k<bmiDataTest->bins;k++)
//     {
//       for(int l=0;l<bmiDataTest->trials;l++)
//       {
// 	fprintf(inputdata5,"%d\n",bmiDataTest->data[k][l][j][0]);
// 	fflush(inputdata5);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->channels;j++)
//   {
//     for(int k=0;k<bmiDataTest->bins;k++)
//     {
//       for(int l=0;l<bmiDataTest->trials;l++)
//       {
// 	fprintf(inputdata6,"%d\n",bmiDataTest->data[k][l][j][0]);
// 	fflush(inputdata6);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->channels;j++)
//   {
//     for(int k=0;k<bmiDataTest->bins;k++)
//     {
//       for(int l=0;l<bmiDataTest->trials;l++)
//       {
// 	fprintf(inputdata7,"%d\n",bmiDataTest->data[k][l][j][0]);
// 	fflush(inputdata7);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->channels;j++)
//   {
//     for(int k=0;k<bmiDataTest->bins;k++)
//     {
//       for(int l=0;l<bmiDataTest->trials;l++)
//       {
// 	fprintf(inputdata8,"%d\n",bmiDataTest->data[k][l][j][0]);
// 	fflush(inputdata8);
//       }
//     }
//   }
//   for(int j=0;j<bmiDataTrain->trials;j++)
//   {
//     for(int k=0;k<bmiDataTrain->channels;k++)
//     {
//       for(int l=0;l<bmiDataTrain->bins;l++)
//       {
// 	fprintf(inputdata1,"%d\n",bmiDataTrain->data[l][j][k][0]);
// 	fflush(inputdata1);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTrain->trials;j++)
//   {
//     for(int k=0;k<bmiDataTrain->channels;k++)
//     {
//       for(int l=0;l<bmiDataTrain->bins;l++)
//       {
// 	fprintf(inputdata2,"%d\n",bmiDataTrain->data[l][j][k][1]);
// 	fflush(inputdata2);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTrain->trials;j++)
//   {
//     for(int k=0;k<bmiDataTrain->channels;k++)
//     {
//       for(int l=0;l<bmiDataTrain->bins;l++)
//       {
// 	fprintf(inputdata3,"%d\n",bmiDataTrain->data[l][j][k][2]);
// 	fflush(inputdata3);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTrain->trials;j++)
//   {
//     for(int k=0;k<bmiDataTrain->channels;k++)
//     {
//       for(int l=0;l<bmiDataTrain->bins;l++)
//       {
// 	fprintf(inputdata4,"%d\n",bmiDataTrain->data[l][j][k][3]);
// 	fflush(inputdata4);
//       }
//     }
//   }
  
  
//   for(int j=0;j<bmiDataTest->trials;j++)
//   {
//     for(int k=0;k<bmiDataTest->channels;k++)
//     {
//       for(int l=0;l<bmiDataTest->bins;l++)
//       {
// 	fprintf(inputdata5,"%d\n",bmiDataTest->data[l][j][k][0]);
// 	fflush(inputdata5);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->trials;j++)
//   {
//     for(int k=0;k<bmiDataTest->channels;k++)
//     {
//       for(int l=0;l<bmiDataTest->bins;l++)
//       {
// 	fprintf(inputdata6,"%d\n",bmiDataTest->data[l][j][k][1]);
// 	fflush(inputdata6);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->trials;j++)
//   {
//     for(int k=0;k<bmiDataTest->channels;k++)
//     {
//       for(int l=0;l<bmiDataTest->bins;l++)
//       {
// 	fprintf(inputdata7,"%d\n",bmiDataTest->data[l][j][k][2]);
// 	fflush(inputdata7);
//       }
//     }
//   }
//   
//   for(int j=0;j<bmiDataTest->trials;j++)
//   {
//     for(int k=0;k<bmiDataTest->channels;k++)
//     {
//       for(int l=0;l<bmiDataTest->bins;l++)
//       {
// 	fprintf(inputdata8,"%d\n",bmiDataTest->data[l][j][k][3]);
// 	fflush(inputdata8);
//       }
//     }
//   }
  
}


void StringToVector(string str, std::vector<short>* vec)
{
  int i=0;
  int len=0;

  while(i<str.length())
  {
    while( (str.at(i)!=' ') )
    {
      len++;
      i++;
       if (i==str.length()) break; 
    }
    
    string temp = str.substr(i-len,len);
    vec->push_back(atoi(temp.c_str()));
    len=0;

    if (i<str.length())
    {
      while( (str.at(i)==' ') )
      {
	i++;
	if (i==str.length()) break; 
      }    
    }
  }
}

void StringTo4DMatrix(string str, dataset* bmiData, idx4D trial, idx4D channel, idx4D stim)
{
  int i=0;
  int len=0;
  idx4D curr_bin=0;

  while(i<str.length())
  {
    while( (str.at(i)!=' ') )
    {
      len++;
      i++;
       if (i==str.length()) break; 
    }
    
    string temp = str.substr(i-len,len);
    bmiData->data[curr_bin][trial][channel][stim]=short((atoi(temp.c_str())));
    cout<<"data:"<<bmiData->data[curr_bin][trial][channel][stim]<<" curr_bin:"<<curr_bin<<" len:"<<len<<" i:"<<i<<endl;
    curr_bin++;
    
    len=0;

    if (i<str.length())
    {
      while( (str.at(i)==' ') )
      {
	i++;
	if (i==str.length()) break; 
      }    
    }
  }
  
  if(curr_bin < bmiData->bins )
  {
   cout << "Error : Not enough data!"<< '\n'; 
  }
  
}

void StringShortTo4DMatrix(string str, dataset* bmiData, idx4D trial, idx4D channel, idx4D stim)
{
  int i=0;
  
  idx4D curr_bin=0;

  while(i<str.length()-1)
  {
       
    string temp = str.substr(i,1);
    bmiData->data[curr_bin][trial][channel][stim]=short((atoi(temp.c_str())));
    
    curr_bin++;
    i++;
    
  }
  
  if(curr_bin < bmiData->bins )
  {
   cout << "Error : Not enough data!"<< '\n'; 
  }
  
}
  
void pause( unsigned long ms )
{  
  usleep( ms * 1000 );
}

void decoder(forceField motorMap,std::vector<float> outputLayer,double gainFactor,std::vector<double> *F)
{
  double outputSpikes[outputLayer.size()];
  for(int i=0;i<outputLayer.size();i++)
  {
    if(outputLayer[i]>0)
    {
      outputSpikes[i]=outputLayer[i];
    }
    else
    {
      outputSpikes[i]=0;
    }
//     cout<<"outputSpikes ["<<i<<"] = "<<outputSpikes[i]<<endl;
  }
//   double maxOutput=*max_element(outputSpikes,outputSpikes+outputLayer.size());
  double forceWeight=1/gainFactor;
  F->operator[](0)=( forceWeight*outputSpikes[0]*motorMap.meanForce[0].at(0)+forceWeight*outputSpikes[1]*motorMap.meanForce[1].at(0)+forceWeight*outputSpikes[2]*motorMap.meanForce[2].at(0)+forceWeight*outputSpikes[3]*motorMap.meanForce[3].at(0) );
  F->operator[](1)=( forceWeight*outputSpikes[0]*motorMap.meanForce[0].at(1)+forceWeight*outputSpikes[1]*motorMap.meanForce[1].at(1)+forceWeight*outputSpikes[2]*motorMap.meanForce[2].at(1)+forceWeight*outputSpikes[3]*motorMap.meanForce[3].at(1) );
//   F->operator[](0)=( forceWeight*outputLayer.at(0).size()*motorMap.meanForce[0].at(0)+forceWeight*outputLayer.at(1).size()*motorMap.meanForce[1].at(0)+forceWeight*outputLayer.at(2).size()*motorMap.meanForce[2].at(0)+forceWeight*outputLayer.at(3).size()*motorMap.meanForce[3].at(0) );
//   F->operator[](1)=( forceWeight*outputLayer.at(0).size()*motorMap.meanForce[0].at(1)+forceWeight*outputLayer.at(1).size()*motorMap.meanForce[1].at(1)+forceWeight*outputLayer.at(2).size()*motorMap.meanForce[2].at(1)+forceWeight*outputLayer.at(3).size()*motorMap.meanForce[3].at(1) );

}

void inv(matrix2Dd InputMatrix, matrix2Dd &InverseMatrix)
{
	// Create a duplicate of the input matrix
	int N = InputMatrix.size1();
	matrix2Dd A = InputMatrix;

	// Create the permutation matrix
	typedef permutation_matrix<std::size_t> pmatrix;
	pmatrix P(N);

	// Assign the identity matrix to the inverse
	InverseMatrix.assign(identity_matrix<double>(N));

	//LU factorization and substitution
	lu_factorize(A,P);
	lu_substitute(A,P,InverseMatrix);
}

bool DynSys(dynamicParam DS, std::vector< double >* position, std::vector< double >* velocity, std::vector< double > Force, motorHandle MH, int s, sockaddr_in si_me, sockaddr_in si_other)
{
  std::string TXString;
  std::string ACKstring("ACK");
  std::vector<double> old_position(*position);
  std::vector<double> old_velocity(*velocity);
  
  cout<<"Initial position :"<<old_position[0]<<","<<old_position[1]<<endl;
  cout<<"Initial velocity :"<<old_velocity[0]<<","<<old_velocity[1]<<endl;
  cout<<endl;
  
  int normal[]={1,1};
  double acc[2];
  matrix2Dd invMass(2,2);
  double dt=double(DS.deltaTime)/1000;
  inv(DS.mass,invMass);
  bool targetReached=false;
  
  for(int i=0;i<DS.interTime/DS.deltaTime;i++)
  {
    if(i==0) //apply force just first time
    {
      
      acc[0]=-invMass(0,0)*(DS.damping(0,0)*old_velocity[0]-Force[0] );
      acc[1]=-invMass(1,1)*(DS.damping(1,1)*old_velocity[1]-Force[1] );
//       cout<<"Initial Force :"<<Force[0]<<","<<Force[1]<<endl;
    }
    else
    {
      acc[0]=-invMass(0,0)*(DS.damping(0,0)*old_velocity[0] );
      acc[1]=-invMass(1,1)*(DS.damping(1,1)*old_velocity[1] );
    }
//     cout<<"Current Acceleration:"<<acc[0]<<","<<acc[1]<<endl;
    
    velocity->operator[](0)=acc[0]*dt + old_velocity[0];
    velocity->operator[](1)=acc[1]*dt + old_velocity[1];
//     cout<<"Current velocity:"<<velocity->operator[](0)<<","<<velocity->operator[](1)<<endl;

    position->operator[](0)=old_position[0]+velocity->operator[](0)*dt;
    position->operator[](1)=old_position[1]+velocity->operator[](1)*dt;
//     cout<<"Current position:"<<position->operator[](0)<<","<<position->operator[](1)<<endl;
    
    if((position->operator[](0)<=DS.rangeX[0]) || (position->operator[](0)>=DS.rangeX[1]) )//check if elastic collision
    {
       normal[0]=-1;
       velocity->operator[](0)=velocity->operator[](0)*normal[0];
       position->operator[](0)=old_position[0]+velocity->operator[](0)*dt;
       cout<<"Inversion along x axis -> [vx:"<< velocity->operator[](0)<<"px:"<<position->operator[](0)<<"]"<<endl; 
    }
    if((position->operator[](1)<=DS.rangeY[0]) || (position->operator[](1)>=DS.rangeY[1]) )  //check if elastic collision
    {
      normal[1]=-1;
      velocity->operator[](1)=velocity->operator[](1)*normal[1];
      position->operator[](1)=old_position[1]+velocity->operator[](1)*dt;
      cout<<"Inversion along y axis -> [vy:"<< velocity->operator[](1)<<"py:"<<position->operator[](1)<<"]"<<endl; 
    }

    old_position=*position;
    old_velocity=*velocity;
    
    moveMotor(old_position,MH);

    cout<<endl;
    
    TXString=(static_cast<ostringstream*>( &(ostringstream() << old_position[0] ) )->str() );
    TXString+=' ';
    TXString+=(static_cast<ostringstream*>( &(ostringstream() << old_position[1] ) )->str() );
    
    sendUDPString( s,si_other,&TXString);
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    
    if( sqrt(pow(old_position[0],2)+pow(old_position[1],2)) <= DS.radius ) //if in the target area
    {
      cout<<"Target Reached!"<<endl;
      targetReached=true;
      TXString="999"; //999 code define the event "target reached"
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
      break;
      
    }

    pause(DS.deltaTime);
    
  }
  return targetReached;
}
