#include <iostream>
#include <stdio.h> 
#include <string> 
#include <stdlib.h> 
#include <unistd.h>
#include <math.h>
#include <fstream>
#include <sys/time.h>
#include <stddef.h>
#include <fcntl.h>
#include <Python.h>
#include <unistd.h>
#include <sys/ioctl.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <time.h>
#include "NM256lib.h"
#include "boost/multi_array.hpp"
#include <boost/random/mersenne_twister.hpp>
#include <boost/random/uniform_int_distribution.hpp>


void write_generic_neuelab_reg (int fp, unsigned int offset, unsigned int data) {
	neuelab_gen_reg_t reg;

	reg.rw=1;
	reg.data=data;
	reg.offset=offset;

	ioctl(fp,NEUELAB_GEN_REG,&reg);
}

unsigned int read_generic_neuelab_reg (int fp, unsigned int offset) {
	neuelab_gen_reg_t reg;

	reg.rw=0;
	reg.offset=offset;

	ioctl(fp,NEUELAB_GEN_REG,&reg);
	return reg.data;
}

int resetMN256(int handle)
{
	
  int neurons =NEURONS;
  int plastic_syn =PLASTIC_SYN;
  int nonplastic_syn =NONPLASTIC_SYN;
  unsigned long version;
  unsigned char hw_major,hw_minor;
  char stringa[4];
  int i,ans;

  ioctl(handle,NEUELAB_VERSION,&version);
  ioctl(handle,NEUELAB_SETLOOPBACK,0);
  hw_major=(version&0xF0)>>4;
  hw_minor=(version&0x0F)    ;
  stringa[3]=0;
  for (i=0;i<3;i++) 
  {
	stringa[i]=(version&0xFF000000)>>24;
	version=version<<8;
  }
  printf ("\r\nIdentified: %s version %d.%d\r\n\r\n",stringa,hw_major,hw_minor);
  // Write Time regs for mn256
  write_generic_neuelab_reg(handle, BIAS_REG,   0x000F0000);
  write_generic_neuelab_reg(handle, PRESC_REG,   0x00000001);


  // Start IP and fludh FIFOs
  write_generic_neuelab_reg(handle, CTRL_REG, CTRL_MN256CHIPTYPE | CTRL_ENABLEIP | CTRL_FLUSHFIFO);

  //re-initiliazi bias
  initBias256(handle);
  /*//sendGenericCMD(ASSERT_RESET_NEURON_BUF,0,handle);
  //sendGenericCMD(DEASSERT_RESET_NEURON_BUF,0,handle);
  ans=0;

  while(ans==0)
  {
    cout << "Do you shortcut req_TX with ack_TX? [yes=1,no=0] ";
    cin >> ans;
  }*/
  //reset synapses
  for(int i=0;i<neurons;i++)
  {
    for(int j=0;j<nonplastic_syn;j++)
    {
      setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
      setNonPlastic(j,i,RESET_SYN,BRD_NONPLASTIC,handle); //write broadcast
      setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle);//write weight
      setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);//write weight
      setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle);//write if excitatory
    }
    for(int k=0;k<plastic_syn;k++)
    {
      setPlasticLatch(k,i,RESET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
      setPlasticLatch(k,i,RESET_SYN,BRD_PLASTIC,handle);//write broadcast
      setPlasticHL(k,i,LOW_STATE_PLASTIC,handle);
    }
  }

  //reset bias latches
  sendGenericCMD(ASSERT_RESET_BIAS_LATCH,0,handle);
  sendGenericCMD(DEASSERT_RESET_BIAS_LATCH,0,handle);


printf("MN256 and Bias Resetted!\n");
}

void importBynaryBias(FILE *fp, int neuFile)
{
        char biasName[20], coarseCurrent[20],LowHigh[20],CasNor[20],PN[20],DisEn[20];
        int refinedCurrent;
        int address=-1;
   	if(fp!=NULL)
	{
        	while( fscanf(fp,"%s %s %d %s %s %s %s \n",biasName,coarseCurrent,&refinedCurrent,LowHigh,CasNor,PN,DisEn)!=EOF)
		{
                 	address++;
			//printf("Bias: %s %s %d %s %s %s %s\n",biasName,coarseCurrent,refinedCurrent,LowHigh,CasNor,PN,DisEn);
 			bias_t Bias;
 			Bias.time = 0;
			Bias.bias = BIAS_PROGRAMMING |
                      	(address & 0x7F)<<16 ;
                        printf("Bias (%d): %s ",address,biasName);
			//search for correct CC
			if(strcmp(coarseCurrent,"24u")==0) 
			{
				Bias.bias = Bias.bias | CC_24u;
				printf("24u ");
			}
    			else if(strcmp(coarseCurrent,"3.2u")==0)
			{
				Bias.bias = Bias.bias | CC_3p2u;
				printf("3.2u ");
			}
			else if(strcmp(coarseCurrent,"0.4u")==0)
			{
				Bias.bias = Bias.bias | CC_0p4u;
				printf("0.4u ");
			}
			else if(strcmp(coarseCurrent,"50n")==0)
			{
				Bias.bias = Bias.bias | CC_50n;
				printf("50n ");
			}
			else if(strcmp(coarseCurrent,"6.5n")==0)
			{
				Bias.bias = Bias.bias | CC_6p5n;
				printf("6.5n ");
			}
			else if(strcmp(coarseCurrent,"820p")==0)
			{
				Bias.bias = Bias.bias | CC_820p;
				printf("820p ");
			}
			else if(strcmp(coarseCurrent,"105p")==0)
			{
				Bias.bias = Bias.bias | CC_105p;
				printf("105p ");
			}
			else if(strcmp(coarseCurrent,"15p")==0)
			{
				Bias.bias = Bias.bias | CC_15p;
				printf("15p ");
			}
			else if(strcmp(coarseCurrent,"SPECIAL")==0)
			{
				Bias.bias = Bias.bias | CC_SSP_SSN | CC_15p;
				printf("SPECIAL ");
			}


			//convert refinedC into bynary value
			
			Bias.bias = Bias.bias | (refinedCurrent & 0xFF)<<4;
			printf("%d ",refinedCurrent);

			//LowHig Bias
			if(strcmp(LowHigh,"HighBias")==0) 
			{
				Bias.bias = Bias.bias | BT_HighBias ;
				printf("HighBias ");
			}
    			else if(strcmp(LowHigh,"LowBias")==0)
			{
				Bias.bias = Bias.bias | BT_LowBias ;
				printf("LowBias ");
			}

			//cascode normal Bias
			if(strcmp(CasNor,"Normal")==0) 
			{
				Bias.bias = Bias.bias | BT_NormalBias ;
				printf("Normal ");
			}
    			else if(strcmp(CasNor,"CascodeBias")==0)
			{
				Bias.bias = Bias.bias | BT_CascodeBias ;
				printf("CascodeBias ");
			}

			// PN Bias
			if(strcmp(PN,"NBias")==0) 
			{
				Bias.bias = Bias.bias | BT_NBias;
				printf("NBias ");
			}
    			else if(strcmp(PN,"PBias")==0)
			{
				Bias.bias = Bias.bias | BT_PBias ;
				printf("PBias ");
			}

			// EnDis Bias
			if(strcmp(DisEn,"BiasEnable")==0) 
			{
				Bias.bias = Bias.bias | BT_BiasEnable;
				printf("BiasEnable ");
			}
    			else if(strcmp(DisEn,"BiasDisable")==0)
			{
				Bias.bias = Bias.bias | BT_BiasDisable ;
				printf("BiasDisable ");
			}

			
			//printf("Bias: Time: 0x%08X Data: 0x%08X\n",Bias.time, Bias.bias);
			write (neuFile, (char *)&Bias, 1*sizeof(bias_t));
			printf("\n");
		}
		

	}

}

int initBias256(int fp)
{
 
        FILE *fpBias;

        char my_filename[] = "biasList.txt";
        fpBias=fopen(my_filename,"r");
	if(fpBias==NULL)
        {
		printf("Cannot open bias configuration file!\n");
	}
	else
	{
		printf("Bias configuration file opened!\n");
  		importBynaryBias(fpBias, fp); //import bias from txt file
  		fclose(fpBias);
	}

  	return 1;
  
}

int initMN256(int classes,int neuronPerClass,int Input,int handle)
{
  
  
  int res=-1;
  int neurons =NEURONS;
  int synapses =PLASTIC_SYN+NONPLASTIC_SYN;
  int outputNeurons=(classes*neuronPerClass);
  int hiddenNeurons=neurons-outputNeurons;
  int offset_np=PLASTIC_SYN;
  int thOutput=0;//neurons-outputNeurons;
  int EIvec[] = {0,0,0,1,1,1,1,1,1,1}; //30%inhibiotory, 70%excitatory
  boost::random::mt19937 gen;
  boost::random::uniform_int_distribution<> dist(0, 9);
  
  ioctl(handle,NEUELAB_OUTNEUTHRESHOLD, thOutput); //set hw threshold for output neurons

  if(hiddenNeurons>=Input)
  {
    res=1;
    //////////////////////////////////////qui bisogna abilitare la plasticità neurale/////////////////////
    // create conection matrices
    matrix2Di R(neurons,synapses); //recurrency matrix
    matrix2Di W(neurons,synapses); //weight matrix
    matrix2Di B(neurons,synapses); //broadcast matrix
    matrix2Di EI(neurons,synapses); //excitatory/inhibitory matrix
    // clear connection matrices
    R.clear();
    W.clear();
    B.clear();
    EI.clear();
    //create non-plastic connection between input and hidden layer
    for (int i=0;i<hiddenNeurons;i++)
    {
      for (int j=0;j<Input;j++)
      {
	B(i,j+offset_np)=1;
	R(i,j+offset_np)=0;
	W(i,j+offset_np)=rand()%2;
	EI(i,j+offset_np)=EIvec[dist(gen)];
	
	//write to nm256
	setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j,i,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	if(W(i,j+offset_np)==1)//write weight 
	{
	  setNonPlastic(j,i,SET_SYN,W0_NONPLASTIC,handle);
	  setNonPlastic(j,i,SET_SYN,W1_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle); 
	  setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);
	}
	if(EI(i,j+offset_np)==1)//write if excitatory/inhibitory synapses 
	{
	  setNonPlastic(j,i,SET_SYN,ER_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle); 
	}
	
      }
    }
    //create non-plastic connection between teaching signal and output layer
    for(int j=0;j<classes;j++)
    {
      for (int i=0;i<neuronPerClass;i++)
      {
	B(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	R(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=0;
	W(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	EI(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	
	//write to nm256
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W0_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W1_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,ER_NONPLASTIC,handle);//write if excitatory

      }
    }
    //create plastic connection between HL and OL
    for(int i=0;i<outputNeurons;i++)
    {
      for(int j=0;j<hiddenNeurons;j++)
      {
	B(i+hiddenNeurons,j)=1;
	R(i+hiddenNeurons,j)=1;
	W(i+hiddenNeurons,j)=rand()%2;
	
	//write to nm256
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,BRD_PLASTIC,handle);//write broadcast
	
	if(W(i+hiddenNeurons,j)==1)//write state
	{
	  setPlasticHL(j,i+hiddenNeurons,HIGH_STATE_PLASTIC,handle);
	}
	else
	{
	  setPlasticHL(j,i+hiddenNeurons,LOW_STATE_PLASTIC,handle);
	}
	  
      }
    }
    
    //////////printout process
    FILE* fp_w = fopen("WeightMatrix.txt", "w+");
    FILE* fp_r = fopen("RecurrencyMatrix.txt", "w+");
    FILE* fp_b = fopen("BroadcastMatrix.txt", "w+");
    FILE* fp_ei = fopen("EIMatrix.txt", "w+");
    
    for(int i=0;i<neurons;i++)
    {
      for(int j=0;j<synapses;j++)
      {
	fprintf(fp_w, "%d %s", W(i,j)," ");
	fprintf(fp_r, "%d %s", R(i,j)," ");
	fprintf(fp_b, "%d %s", B(i,j)," ");
	fprintf(fp_ei, "%d %s", EI(i,j)," ");
      }
      fprintf(fp_w, "\n" );
      fprintf(fp_r, "\n");
      fprintf(fp_b, "\n");
      fprintf(fp_ei, "\n");
    }
    fclose(fp_w);
    fclose(fp_r);
    fclose(fp_b);
    fclose(fp_ei);
    ////////

    printf("MN256 initiliazed with dimension (IL x HL x OL): %d x %d x %d ",Input,hiddenNeurons,outputNeurons);
  }
  
  return res;
}

int configureMN256(matrix2Di W,matrix2Di EI,int classes,int neuronPerClass,int Input,int handle)
{
  //set the mn256 accordingly to the python code
  int res=-1;
  int neurons =NEURONS;
  int synapses =PLASTIC_SYN+NONPLASTIC_SYN;
  int outputNeurons=(classes*neuronPerClass);
  int hiddenNeurons=neurons-outputNeurons;
  int offset_np=PLASTIC_SYN;
  int thOutput=0;//neurons-outputNeurons;
  ioctl(handle,NEUELAB_OUTNEUTHRESHOLD, thOutput); //set hw threshold for output neurons
  if(W.size1()!=neurons || W.size2()!=synapses)
  {
    cout<<"Wrong size of weight matrix!"<<endl;
  }
  else if(EI.size1()!=neurons || EI.size2()!=synapses)
  {
    cout<<"Wrong size of excitatory matrix!"<<endl;
  }
  else if(hiddenNeurons>Input)
  {
    res=1;
    //////////////////////////////////////qui bisogna disabilitare la plasticità neurale/////////////////////
    // create conection matrices
    matrix2Di R(neurons,synapses); //recurrency matrix
    matrix2Di B(neurons,synapses); //broadcast matrix
    // clear connection matrices
    R.clear();
    B.clear();
    //create non-plastic connection between input and hidden layer
    for (int i=0;i<hiddenNeurons;i++)
    {
      for (int j=0;j<Input;j++)
      {
	B(i,j+offset_np)=1;
	R(i,j+offset_np)=0;
	
	//write to nm256
	setNonPlastic(j,i,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j,i,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	if(W(i,j+offset_np)==1)//write weight 
	{
	  setNonPlastic(j,i,SET_SYN,W0_NONPLASTIC,handle);
	  setNonPlastic(j,i,SET_SYN,W1_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,W0_NONPLASTIC,handle); 
	  setNonPlastic(j,i,RESET_SYN,W1_NONPLASTIC,handle);
	}
	if(EI(i,j+offset_np)==1)//write if excitatory/inhibitory synapses 
	{
	  setNonPlastic(j,i,SET_SYN,ER_NONPLASTIC,handle);
	}
	else
	{
	  setNonPlastic(j,i,RESET_SYN,ER_NONPLASTIC,handle); 
	}
	
      }
    }
    //create non-plastic connection between teaching signal and output layer
    for(int j=0;j<classes;j++)
    {
      for (int i=0;i<neuronPerClass;i++)
      {
	B(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=1;
	R(i+hiddenNeurons+neuronPerClass*j,j+offset_np+neurons-classes)=0;
	
	//write to nm256
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,RESET_SYN,RECURRENT_NONPLASTIC,handle); //write recurrency
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,BRD_NONPLASTIC,handle); //write broadcast
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W0_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,W1_NONPLASTIC,handle);//write weight
	setNonPlastic(j+neurons-classes,i+hiddenNeurons+neuronPerClass*j,SET_SYN,ER_NONPLASTIC,handle);//write if excitatory

      }
    }
    //create connection between HL and OL
    for(int i=0;i<outputNeurons;i++)
    {
      for(int j=0;j<hiddenNeurons;j++)
      {
	B(i+hiddenNeurons,j)=1;
	R(i+hiddenNeurons,j)=1;
	
	//write to nm256
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,RECURRENT_PLASTIC,handle);//write recurrency
	setPlasticLatch(j,i+hiddenNeurons,SET_SYN,BRD_PLASTIC,handle);//write broadcast
	
	if(W(i+hiddenNeurons,j)==1)//write state
	{
	  setPlasticHL(j,i+hiddenNeurons,HIGH_STATE_PLASTIC,handle);
	}
	else
	{
	  setPlasticHL(j,i+hiddenNeurons,LOW_STATE_PLASTIC,handle);
	}
	  
      }
    }
    
    //////////printout process
    FILE* fp_w = fopen("WeightMatrixOff.txt", "w+");
    FILE* fp_r = fopen("RecurrencyMatrixOff.txt", "w+");
    FILE* fp_b = fopen("BroadcastMatrixOff.txt", "w+");
    FILE* fp_ei = fopen("EIMatrixOff.txt", "w+");
    
    for(int i=0;i<neurons;i++)
    {
      for(int j=0;j<synapses;j++)
      {
	fprintf(fp_w, "%d %s", W(i,j)," ");
	fprintf(fp_r, "%d %s", R(i,j)," ");
	fprintf(fp_b, "%d %s", B(i,j)," ");
	fprintf(fp_ei, "%d %s", EI(i,j)," ");
      }
      fprintf(fp_w, "\n" );
      fprintf(fp_r, "\n");
      fprintf(fp_b, "\n");
      fprintf(fp_ei, "\n");
    }
    fclose(fp_w);
    fclose(fp_r);
    fclose(fp_b);
    fclose(fp_ei);
    ////////
  }
  
  return res;
}

int runMN256(matrix2Di trial,int binSize,int handle)
{
  //run mn256 accordingly to the input trial coming from electrodes or test dataset
  int cnt_spike=0;
  int pkg_time=0;
  spike_t timeVector[trial.size1()*trial.size2()];
  
  //train mn256 with the offline training data
  for(int j=0;j<trial.size2();j++) //loop on bins
  {
    for(int i=0;i<trial.size1();i++) //loop on input channel
    {
      if(trial(i,j)==1)
      {
	//collect spike
	if(cnt_spike==0)//first spike
	{
	  timeVector[cnt_spike].dTclock=START_DELAY;
	  timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;
	  pkg_time=ms2clock(j*binSize);
	}
	else
	{
	  pkg_time=ms2clock(j*binSize)-pkg_time;
	  timeVector[cnt_spike].dTclock=pkg_time;
	  timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;	  
	}
	cnt_spike++;
      }
    }
  }  
  //send spike vector
  write(handle, &timeVector[0], sizeof(spike_t)*cnt_spike);
}

int trainMN256(matrix2Di trial, int label, int binSize, int classes, int handle)
{
  //int cnt_spike=0;
  //int pkg_time=0;
  //spike_t timeVector[trial.size1()*(trial.size2()+1)];
  
  //train mn256 with the trial by trial training data
  for(int j=0;j<trial.size2();j++) //loop on bins
  {
    //send teaching signal
    if(j==0)//first spike
    {
      /*timeVector[cnt_spike].dTclock=START_DELAY;
      timeVector[cnt_spike].command=NONPLASTIC_SYN-classes+label+PLASTIC_SYN+OFF_BRD_SPIKE;
      pkg_time=0;
      cnt_spike++;*/
      sendSpikeBR(NONPLASTIC_SYN-classes+label+PLASTIC_SYN,START_DELAY,handle);
	//usleep(1000);
    }
    else
    {
      /*pkg_time=(j*binSize)-pkg_time;
      timeVector[cnt_spike].dTclock=binSize;
      timeVector[cnt_spike].command=NONPLASTIC_SYN-classes+label+PLASTIC_SYN+OFF_BRD_SPIKE;
      cnt_spike++;*/
      sendSpikeBR(NONPLASTIC_SYN-classes+label+PLASTIC_SYN,binSize,handle);
	//usleep(1000);
    }   
    for(int i=0;i<trial.size1();i++) //loop on input channel
    {
      if(trial(i,j)==1)
      {
	//collect spike
	/*pkg_time=(j*binSize)-pkg_time;
	timeVector[cnt_spike].dTclock=DELTA_SPK_TIME_MS;
	timeVector[cnt_spike].command=i+PLASTIC_SYN+OFF_BRD_SPIKE;
	cnt_spike++;*/
	sendSpikeBR(i+PLASTIC_SYN,DELTA_SPK_TIME_MS,handle);
	//printf("channel %d ms %d\n",i,j*binSize);
      }
    }
  }  
  //send spike vector
  //write(handle, &timeVector[0], cnt_spike*sizeof(spike_t));
}

void sendStimToNM256(matrix2Di trial, int handle)
{
  for(int j=0;j<trial.size2();j++) //loop on bins
  {
   for(int i=0;i<trial.size1();i++) //loop on input channel
    {
      if(trial(i,j)==1)
      {
	sendSpikeBR(i+PLASTIC_SYN,DELTA_SPK_TIME_MS,handle);
      }
    }
  }
}









int setNonPlastic(int syn,int neur, int sr,int latch, int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=0;
  pkg.command=neur+(syn<<8)+sr+latch+OFF_SET_NONPLASTIC;
  //printf("NP Data %d syn %d neur -> %d\n",syn,neur,pkg.command);
  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
    //printf("Warning! Almost full TX!status neuelab: 0x%08X \n",neuElabStat);
  }

  int res=write(handle, (char *)&pkg, 1*sizeof(spike_t));
  return res;
}

int setPlasticLatch(int syn,int neur,int sr,int latch,int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=0;
  pkg.command=neur+(syn<<8)+sr+latch+OFF_SET_PLASTIC_LATCH;
  //printf("PL Data %d syn %d neur -> %d\n",syn,neur,pkg.command);
  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  //printf("status neuelab: 0x%08X \n",neuElabStat);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
    //printf("Warning! Almost full TX!status neuelab: 0x%08X \n",neuElabStat);
  }

  int res=write(handle, (char *)&pkg, 1*sizeof(spike_t));
  return res;
}

int setPlasticHL(int syn, int neur, int hl,int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=0;
  pkg.command=neur+(syn<<8)+hl+OFF_SET_PLASTIC_HL;
  //printf("PL Data %d syn %d neur -> %d\n",syn,neur,pkg.command);
  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  //printf("status neuelab: 0x%08X \n",neuElabStat);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
    //printf("Warning! Almost full TX!status neuelab: 0x%08X \n",neuElabStat);
  }

  int res=write(handle, (char *)&pkg, 1*sizeof(spike_t));
  return res;
}

int sendSpike(int syn, int neur,double dTimeInMS,int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=ms2clock(dTimeInMS);
  pkg.command=neur+(syn<<8)+OFF_SINGLE_SPIKE;
  
  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  //printf("status neuelab: 0x%08X \n",neuElabStat);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
    //printf("Warning! Almost full TX!status neuelab: 0x%08X \n",neuElabStat);
  }

  int res=write(handle, &pkg, 1*sizeof(spike_t));
  //usleep(200);
 // printf ("0x%08X T\n", pkg.dTclock);
 // printf ("0x%08X D\n", pkg.command);
  return res;
}

int sendSpikeBR(int syn,double dTimeInMS,int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=ms2clock(dTimeInMS);
  pkg.command=syn+OFF_BRD_SPIKE;

  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  //printf("status neuelab: 0x%08X \n",neuElabStat);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
    //printf("Warning! Almost full TX!status neuelab: 0x%08X \n",neuElabStat);
  }
  int res=write(handle, (char *)&pkg, 1*sizeof(spike_t));
  return res;
}

int sendGenericCMD(unsigned int command,double dTimeInMS,int handle)
{
  spike_t pkg;
  unsigned int neuElabStat;

  pkg.dTclock=ms2clock(dTimeInMS);
  pkg.command=command;

  neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  while(neuElabStat & MASK_TX_AFULL)
  {
    usleep(200);
    neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
  }
  int res=write(handle, (char *)&pkg, 1*sizeof(spike_t));
  return res;

}

unsigned int ms2clock(double ms)
{
  unsigned int res=(unsigned int)(ms/1000*MN256_CLOCK_HZ);
  //printf("%f ms converted in clk cycle %d\n",ms,res);
  return res;
}

double clock2s(unsigned int clock,int handle)
{
  unsigned int timestampwrap;
  ioctl(handle,NEUELAB_GETTIMESTAMP,&timestampwrap);
//  cout<<"clock: "<< clock <<" timestampwrap: "<< timestampwrap << "-> "<<(double)(timestampwrap) <<"     "<<(pow(2.0, 32.0)-1)<<"     "<<((double)(timestampwrap)*( (pow(2.0, 32.0)-1)/MN256_CLOCK_HZ) )<<"       "<<((double)(clock)/MN256_CLOCK_HZ)<< endl;

  return (double)(((double)(clock)/MN256_CLOCK_HZ) + ((double)(timestampwrap)*((pow(2.0, 32.0)-1)/MN256_CLOCK_HZ)));

}

/*void readData(long msecRecTime, std::vector< int >* output,int handle)
{
 
      	unsigned int *RXDATA,neuElabStat;
 	timespec *initialTime,*currentTime;
     	 //int counterNeuron[NEURONS];
      	int real_data,i;
        long nsecRecTime=msecRecTime*10^6;
	//std::vector<int>::iterator it;
      	
      	
      	clock_gettime(CLOCK_MONOTONIC,initialTime);
	clock_gettime(CLOCK_MONOTONIC,currentTime);
      
	while((currentTime->tv_nsec-initialTime->tv_nsec)<=nsecRecTime)
	{
		
		real_data=read (handle, (char *)RXDATA, 1024*sizeof(unsigned int));		
		for (i=0;i<real_data/sizeof(unsigned int);i++)
		{
			output->push_back(RXDATA[i]);
		}
		clock_gettime(CLOCK_MONOTONIC,currentTime);
	}
}

	
      
void readData(int iter,int handle)
{
      unsigned int *RXDATA,neuElabStat;
      int counterNeuron[NEURONS];
      int real_data,i;
      
      RXDATA=(unsigned int *) calloc(1024,sizeof(unsigned int));
  
      for (int j=0;j<NEURONS;j++)
      {
	counterNeuron[j]=0;
      }

      for(int j=0;j<iter;j++)
      {
	      neuElabStat=read_generic_neuelab_reg(handle,RAWI_REG);
	      if((neuElabStat & MASK_RX_EMPTY)==1) printf("EMPTY RX FIFO!!!!   ");
	      if((neuElabStat & MASK_RX_FULL)==1) printf("FULL RX FIFO!!!!   ");

	      //printf("%d reading cycle\n\n",j);
	      real_data=read (handle, (char *)RXDATA, 1024*sizeof(unsigned int));
	      //printf("Now read... %d data\n", real_data);

	      // Show data
	      for (int i=0; i<real_data/sizeof(unsigned int); i+=2)
	      {
	      	 //printf ("%d -> neuron: %d, time: %f \n",i/2,RXDATA[i+1],clock2s(RXDATA[i], mn256_handle));
	       	 counterNeuron[RXDATA[i+1]]++;
	      }
      }
      for(int j=0;j<NEURONS;j++)
      {
	printf ("%d neuron spikes %d times\n",j,counterNeuron[j]);
      }
      fflush(stdout);


}


void sendStimToNM256(int curr_stim,std::vector< std::vector< float > >* outputLayer)
{
  std::vector<std::vector<float> >::iterator it;
  float n;
  int stim=0;
  srand(time(NULL));
//fake output layer
  
  for( it = outputLayer->begin(); it != outputLayer->end(); ++it )
  {
    if(stim==curr_stim)
    {
      n = rand() % 200 + 100;
    }
    else
    {
      n = rand() % 50;
    }
    for(int i=0;i<n;i++)
    {
      it->resize(it->size());
      it->push_back((float)(rand() % 600));
    }
    stim++;
    cout<<"out->"<<n<<endl;
  }  

}

///////////missmatch functions//////////////

void divideDataset(dataset* Dataset,PyObject *pValue, int hiddenNeurons,double train_fraction,double thr,double gain)
{
    PyObject *pName, *pModule, *pDict, *pFunc,*pArgs,*pFuncTrain,*NN,*pArgs2;
    int spikeCount;
    char data[Dataset->trials*Dataset->stim*Dataset->channels];
    char label[Dataset->trials*Dataset->stim];
    
    //create dataset
    for(int l=0;l<Dataset->stim;l++)
    {
      for(int i=0;i<Dataset->trials;i++)
      {
	for(int j=0;j<Dataset->channels;j++)
	{
	  spikeCount=0;
	  for(int k=0;k<Dataset->bins;k++)
	  {
	    spikeCount=spikeCount+Dataset->data[k][i][j][l];
	  }
	  data[j+i*Dataset->channels+l*Dataset->trials*Dataset->channels]=(char)(((int)'0')+spikeCount);
	}
	label[i+l*Dataset->trials]=(char)(((int)'0')+l);
      }
    }
    data[Dataset->trials*Dataset->stim*Dataset->channels]='\0';
    label[Dataset->trials*Dataset->stim]='\0';

//     // Initialize the Python Interpreter
//     Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    // pFunc is also a borrowed reference 
    cout<<"chiamo la funzione createDataset"<<endl;
    pFunc = PyDict_GetItemString(pDict, "createDataset");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs = Py_BuildValue ("(ssiiddd)",data,label,Dataset->channels,hiddenNeurons,train_fraction,thr,gain);
    PyErr_Print();
    
    if (PyCallable_Check(pFunc)) 
    {
        pValue=PyObject_CallObject(pFunc, pArgs);
	
    } else 
    {
        PyErr_Print();
    }
    
 
     if (pValue != NULL) 
    {
        cout<<"Dataset created"<<endl;
    }
    else 
    {
       cout<<"è andata male"<<endl;
        PyErr_Print();
    }
   
//     cout<<"chiamo la funzione train_mn256"<<endl;
//     pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
//     PyErr_Print();
//     //preparing data to pass as python parameter
//     pArgs2 = Py_BuildValue ("(O)",pValue);
//     PyErr_Print();
//     
//     
//     if (PyCallable_Check(pFuncTrain)) 
//     {
//         NN=PyObject_CallObject(pFuncTrain, pArgs2);
// 	
//     } else 
//     {
//         PyErr_Print();
//     }
    
//       Clean up
      Py_DecRef(pModule);
      Py_DecRef(pName);

//     // Finish the Python Interpreter
//     Py_Finalize();
}


void trainNetwork(PyObject *pValue,PyObject *NN,int neuronsPerClass,int n_epochs)
{
    cout<<"training network..."<<endl;
    
     if (pValue != NULL) 
    {
        cout<<"input data created"<<endl;
        Py_DECREF(pValue);
    }
    else 
    {
       cout<<"è andata male"<<endl;
        PyErr_Print();
    }
    
    PyObject *pName, *pModule, *pDict, *pFuncTrain, *pArgs2;
    
//     Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    //pFunc is also a borrowed reference 
    cout<<"chiamo la funzione train_mn256"<<endl;
    pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs2 = Py_BuildValue ("(O)",pValue);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFuncTrain)) 
    {
        NN=PyObject_CallObject(pFuncTrain, pArgs2);
	
    } else 
    {
        PyErr_Print();
    }
    
    // Clean up
//     Py_DecRef(pModule);
//     Py_DecRef(pName);
// 
//     // Finish the Python Interpreter
//     Py_Finalize();
  
}

void create(int input,PyObject *pValue)
{
   PyObject *pName, *pModule, *pDict, *pFunc, *pArgs;
    
    Py_Initialize();

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    //pFunc is also a borrowed reference 
    cout<<"chiamo la funzione create"<<endl;
    pFunc = PyDict_GetItemString(pDict, "createStruct");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs = Py_BuildValue ("(i)",1);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFunc)) 
    {
        pValue=PyObject_CallObject(pFunc, pArgs);
	
    } else 
    {
        PyErr_Print();
    }
}

void read(PyObject *pValue)
{
   PyObject *pName, *pModule, *pDict, *pFunc2, *pArgs2;
  

    PyRun_SimpleString("import sys");
    PyRun_SimpleString("sys.path.append(\".\")");
    // Build the name object
    pName = PyString_FromString("mn256");
    PyErr_Print();
    // Load the module object
    cout<<"chiamo il modulo mn256.py"<<endl;
    pModule = PyImport_Import(pName);
    PyErr_Print();
    cout<<"modulo chiamato"<<endl;
    // pDict is a borrowed reference 
    pDict = PyModule_GetDict(pModule);
    PyErr_Print();
    cout<<"chiamo la funzione read"<<endl;
    pFunc2 = PyDict_GetItemString(pDict, "readData");
    PyErr_Print();
    //preparing data to pass as python parameter
    pArgs2 = Py_BuildValue ("(O)",pValue);//,neuronsPerClass,n_epochs);
    PyErr_Print();
    
    
    if (PyCallable_Check(pFunc2)) 
    {
        PyObject_CallObject(pFunc2, pArgs2);
	
    } else 
    {
        PyErr_Print();
    }
}*/
