#include <iostream>
#include<stdio.h> 
#include<string.h> 
#include<stdlib.h> 
#include <unistd.h>
#include<arpa/inet.h>
#include<sys/socket.h>

  
using namespace std;
  
#define SOCKET_MEM 65535

void die(char *s)
{
    perror(s);
    exit(1);
}

void sendUDPInput(int s,struct sockaddr_in si_other)
{
  char message[SOCKET_MEM];
  int  i, slen=sizeof(si_other);
  bool abort_transmission=false;
  printf("Ready to transmit\n");
    
  while(abort_transmission==false)
  {
        gets(message);
        printf("Enter message : ");
        
	
        //send the message
        if (sendto(s, message, sizeof(message) , 0 , (struct sockaddr *) &si_other, slen)==-1)
        {
            die("sendto()");
        }
	if(strncmp(message,"quit",4)==0)
	{
	    printf("Quitting UDP transmission\n");
	    abort_transmission=true;
	}
        //clear the buffer by filling null, it might have previously received data
        memset(message,'\0', SOCKET_MEM);
  }

}

void receiveUDPInput(int s,struct sockaddr_in si_me,struct sockaddr_in si_other, char* total_buf)
{
  int recv_len;
  char buf[SOCKET_MEM];
  int slen=sizeof(si_other);
  bool abort_reception=false;
  
  printf("Ready to receive\n");
 // zero out the structure of total_buf
  memset(total_buf, '\0', SOCKET_MEM);

   while(abort_reception==false)
  {
	  fflush(stdout);

	  //try to receive some data, this is a blocking call
	  if ((recv_len = recvfrom(s, buf, SOCKET_MEM, 0, (struct sockaddr *) &si_other, (socklen_t *) &slen)) == -1)
	  {
	      die("recvfrom()");
	  }
	   //print details of the client/peer and the data received
	  printf("Received packet from %s:%d: ", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	  printf("%.*s",recv_len-1 , buf);
	  printf(" (%dB)\n" , recv_len);
	  if(strncmp(buf,"quit",4)==0)
	  {
	     printf("Quitting UDP reception\n");
	     abort_reception=true;
	  }
	 else
	 {
	     strncat (total_buf, buf,recv_len-1);
	 }
  }
  
}

void sendUDPData(int s,struct sockaddr_in si_other,char* message)
{
  int  i, slen=sizeof(si_other);
  printf("Ready to transmit\n");
    
  
        //send the message
        if (sendto(s, message, sizeof(message) , 0 , (struct sockaddr *) &si_other, slen)==-1)
        {
            die("sendto()");
        }
        else
	{
	    //clear the buffer by filling null, it might have previously received data
	    
	    printf("Packet succesfully transmitted to %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	    memset(message,'\0', SOCKET_MEM);
	    printf("Packet destroied!\n");
	}
}

void sendUDPDataResized(int s,struct sockaddr_in si_other,char* message, int sizeMessage)
{
  int  i, slen=sizeof(si_other);
  printf("Ready to transmit\n");
    
  
        //send the message
        if (sendto(s, message, sizeMessage , 0 , (struct sockaddr *) &si_other, slen)==-1)
        {
            die("sendto()");
        }
        else
	{
	    //clear the buffer by filling null, it might have previously received data
	    
	    printf("Packet succesfully transmitted to %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	    memset(message,'\0', SOCKET_MEM);
	    printf("Packet destroied!\n");
	}
}

void receiveUDPData(int s,struct sockaddr_in si_me,struct sockaddr_in si_other,  char* total_buf)
{
  int recv_len;
  //socklen_t slen;
  int slen=sizeof(si_other);
printf("Ready to receive\n");


	  //fflush(stdout);
	  memset(total_buf,'\0', SOCKET_MEM);
	  
	  //try to receive some data, this is a blocking call
	  if ((recv_len = recvfrom(s, (void *) total_buf, SOCKET_MEM, 0, (struct sockaddr *) &si_other, (socklen_t *) &slen)) == -1)
	  {
	      die("recvfrom()");
	  }
	  else if (recv_len>=SOCKET_MEM) 
	  {
	    printf("Input buffer size too small! Packet rejected.\n");
	  } 
	  else 
	  {
	      printf("Packet successfully received from %s:%d", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	      printf(" (%dB)\n" , recv_len);     
	  }
	  
}

void sendUDPString(int s,struct sockaddr_in si_other,string* message)
{
  int  i, slen=sizeof(si_other);
  //printf("Ready to transmit\n");
  //cout<< "size message (len "<< message->length() <<") in B: " << message->size() <<endl;
  
	//send the message
	if (sendto(s, message->c_str(), message->length() , 0 , (struct sockaddr *) &si_other, slen)==-1)
	{
	    die("sendto()");
	}
	else
	{
	    //clear the buffer by filling null, it might have previously received data
	    
// 	    printf("Packet succesfully transmitted to %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	    //memset(message,'\0', SOCKET_MEM);
	   // message->clear();
	  //  printf("Packet destroied!\n");
	}
}

void sendUDPStringResized(int s,struct sockaddr_in si_other,string* message,int sizeMessage)
{
  int  i, slen=sizeof(si_other);
  //printf("Ready to transmit\n");
  //cout<< "size message (len "<< message->length() <<") in B: " << message->size() <<endl;
  
	//send the message
	if (sendto(s, message->c_str(), sizeMessage , 0 , (struct sockaddr *) &si_other, slen)==-1)
	{
	    die("sendto()");
	}
	else
	{
	    //clear the buffer by filling null, it might have previously received data
	    
// 	    printf("Packet succesfully transmitted to %s:%d\n", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	    //memset(message,'\0', SOCKET_MEM);
	   // message->clear();
	  //  printf("Packet destroied!\n");
	}
}



void receiveUDPString(int s,struct sockaddr_in si_me,struct sockaddr_in si_other,  string* total_buf)
{
	  int recv_len;
	  int slen=sizeof(si_other);
	  char temp_buf[SOCKET_MEM];
	//  printf("Ready to receive\n");
	  
	  //try to receive some data, this is a blocking call
	  if ((recv_len = recvfrom(s, &temp_buf, SOCKET_MEM, 0, (struct sockaddr *) &si_other, (socklen_t *) &slen)) == -1)
	  {
	      die("recvfrom()");
	  }
	  else if (recv_len>=SOCKET_MEM) 
	  {
	    printf("Input buffer size too small! Packet rejected.\n");
	  } 
	  else 
	  {
	      //printf("Packet successfully received from %s:%d", inet_ntoa(si_other.sin_addr), ntohs(si_other.sin_port));
	      //printf(" (%dB)\n" , recv_len);
	  }
	  
	  total_buf->assign(temp_buf,recv_len);
	  
// 	  printf("Data string: %s(Bytes %d)\n",total_buf->c_str(),recv_len);
}


void initUDP (struct sockaddr_in * si_me, struct sockaddr_in * si_other,int * s, const char* IP_OTHER,const int PORT_OTHER,const int PORT_ME)
{

   //create a UDP socket

      int optval=SOCKET_MEM;
      
      if ((*s=socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP)) == -1)
      {
	  die("socket");
      }
 
      // zero out the structure of me
      memset((char *) si_me, 0, sizeof(*si_me));
      si_me->sin_family = AF_INET;
      si_me->sin_port = htons(PORT_ME);
      
      // zero out the structure of other
      memset((char *) si_other, 0, sizeof(*si_other));
      si_other->sin_family = AF_INET;
      si_other->sin_port = htons(PORT_OTHER);
      
      //connect to server
      if (inet_aton(IP_OTHER, &si_other->sin_addr)==0) 
      {
	  fprintf(stderr, "inet_aton() failed\n");
	  exit(1);
      }
      else
      {
	printf("Connection established\n");
	
      }

      //bind socket to port
      if( bind(*s , (struct sockaddr*)si_me, sizeof(*si_me) ) == -1)
      {
	  die("bind");
      }
      else
      {
	printf("Socket bounded to port\n");
      }
      //enlarge I/O socket buffer
       setsockopt (*s, SOL_SOCKET, SO_RCVBUF, &optval, sizeof (optval));
       setsockopt (*s, SOL_SOCKET, SO_SNDBUF, &optval, sizeof (optval));
       
      //keep listening for data
      printf("Ready to send/receive data\n");
      
}
