#include<iostream>
#include<stdio.h> 
#include<string.h> 
#include<stdlib.h> 
#include<unistd.h>
#include<arpa/inet.h>
#include<sys/socket.h>
#include <math.h>
#include <ctime>
#include <cstdlib>
#include <fcntl.h>
#include <Python.h>
#include <pthread.h>
#include <semaphore.h>
#include "boost/multi_array.hpp"
#include "boost/numeric/ublas/matrix.hpp"
#include "boost/numeric/ublas/io.hpp"
#include "/usr/local/lib/python2.7/dist-packages/numpy/core/include/numpy/arrayobject.h"
#include "UDPlib.h"
#include "NM256lib.h" 

using namespace std;
using namespace boost;
using namespace boost::numeric::ublas;

#define RECEIVE_MEM 65535
#define MAX_BUFFER_SIZE 65535
#define TRUE 1
#define FALSE 0

//global variables
const int PORT_OTHER = 9103;   //Port of the other PC
const int  PORT_ME = 9103;   //My port
const char*  IP_OTHER = "10.216.23.188"; //IP adress of the other PC
struct sockaddr_in si_me, si_other; //udp struct
int s, mn256_handle, bufferIdx;
double BUFFER[MAX_BUFFER_SIZE];
bool string_read, end_process;
pthread_mutex_t lock= PTHREAD_MUTEX_INITIALIZER;
pthread_cond_t cond;

//reader from /dev/neuelab
void * reader(void * param)
{
   unsigned int *RXDATA,neuElabStat,rxSize;
   std::string RxString;

   cout<<"Driver reader started!"<< endl << endl;

        while(!end_process)
	{
		usleep(100);
               // while(string_read);
                //lock mutex
                pthread_mutex_lock(&lock);

                //read from device
		neuElabStat=read_generic_neuelab_reg(mn256_handle,RAWI_REG);
	        rxSize=read(mn256_handle, (char *)RXDATA, 1024*sizeof(unsigned int));
		RxString.erase();

		//parse data
	      	for (int i=0; i<rxSize/sizeof(unsigned int); i+=2)
	      	{
	      		 // save tiem stamp
	       		 BUFFER[bufferIdx]=clock2s(RXDATA[i], mn256_handle);
                         //cout<<bufferIdx<<" -> time : "<<BUFFER[bufferIdx];
			 RxString += (static_cast<ostringstream*>( &(ostringstream() << BUFFER[bufferIdx] ) )->str() );
      			 RxString += ' ';
			 bufferIdx=(bufferIdx+1)%MAX_BUFFER_SIZE;

 			 // save neuron
			 BUFFER[bufferIdx]=RXDATA[i+1];
                         //cout<<"   neuron : "<<BUFFER[bufferIdx]<<endl;
			 RxString += (static_cast<ostringstream*>( &(ostringstream() << BUFFER[bufferIdx] ) )->str() );
      			 RxString += ' ';
			 bufferIdx=(bufferIdx+1)%MAX_BUFFER_SIZE;


	     	}
		//send data via udp
		sendUDPString( s,si_other,&RxString);
		//cout<<bufferIdx-1<<" -> time : "<<BUFFER[bufferIdx-2];
		//cout<<"   neuron : "<<BUFFER[bufferIdx-1]<<endl;
		//unlock mutex
                //string_read=TRUE;
                pthread_mutex_unlock(&lock);
                pthread_cond_signal(&cond);
        }
}


/*
//thread2

void * writer(void * param)
{
        while(1){
                pthread_mutex_lock(&lock);
                //while(!string_read)
                pthread_cond_wait(&cond,&lock);
                //read from buffer

		//release mutex
                //string_read=FALSE;
                pthread_mutex_unlock(&lock);
        }
}*/





//BMI algorithm thread
void * bmi(void * param)
{
  
  int bins,trials,channels,stim;
  int numTestTrial,numTrainTrial,maxSteps,deltaTms=200,interTms=2000,ONTrial=1;
  bool flag;
  string fileNameTrain="trainData.mat";   
  string fileNameTest="testData.mat";
  std::vector<double> Force(2);
  std::vector<double> position(2);
  std::vector<double> velocity(2);
  std::vector<double>::iterator its;
  std::vector<std::vector<double> >::iterator it;
  int rangeX[2]={-10,10};
  int rangeY[2]={-10,10};
  double zero[2]={0,0};
  int sensoryResolution=2;
  int neuronPerClass=10;
  double xxmass=10,yymass=10;
  double xxdamp=4,yydamp=4;
  double xxstiff=8,yystiff=8;
  int curr_region,curr_trial;
  short electrodeMap[]={10,5,11,8};
  std::string ACKstring ("ACK");
  std::string TXString;
  std::string data;
  std::string label;
  int stimElectrode;
  double forceWeight,gainFactor,radius=2;
  short ans;
  int binSizeMs=1; 
  int spikeCount; 
  int hiddenNeurons;
  PyObject *pName, *pModule, *pDict;
  PyObject *pFuncInputMatrix,*pFuncOutputMatrix, *pFuncGain,*pFuncData,*pFuncTrain,*pFuncTest, *pFuncTestTot,*pFuncClass;
  PyObject *pArgsInputMatrix,*pArgsOutputMatrix, *pArgsTrain,*pArgsTest,*pArgsData,*pArgsTestTot;
  PyObject *inputWeight,*outputWeight,*outClass,*NN,*inputMN256,*outputGain,*outActivity;

  std::srand (std::time(NULL));
  dataset bmiData(0,0,0,0,"rat");
  
  // Initialize the Python Interpreter
  Py_Initialize();


  /*move into main()

  bufferIdx=0;
  pthread_t tr;
  
  
  // open nm256 chip and initialize it
  mn256_handle=open(MN256_ADDR, O_RDWR | O_SYNC);
  if(mn256_handle < 0) 
  {
     printf("Cannot open /dev/neuelab for write\n");
     return -1;
  }

  /////////////////////udp parameters/////////////////////
  
  initUDP(&si_me,&si_other,&s,IP_OTHER,PORT_OTHER,PORT_ME);

  */

  ////////////////////import dataset//////////////////////
  cout << "Please enter the maximum convergence steps: ";
  cin >> maxSteps;
  cout << "How many output neurons do you wanna assign to each stimulation? ";
  cin >> neuronPerClass;
  cout << "Do you wanna load or import dataset? [import from server=0/load from memorys=1] ";
  cin >> ans;
  if(ans)
  {
    //load last dataset from zedboard hard drive
    TXString=(static_cast<ostringstream*>( &(ostringstream() << ans ) )->str() );
    sendUDPString( s,si_other,&TXString); // inform the server that zedboard doesn't need to import data
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    loadData(&bmiData); // load data and save it in the 4D matrix 'bmiData'
    bins=bmiData.data.shape()[0];
    trials=bmiData.data.shape()[1];
    channels=bmiData.data.shape()[2];
    stim=bmiData.data.shape()[3];
  }
  else
  {
    //import dataset from server
    TXString=(static_cast<ostringstream*>( &(ostringstream() << ans ) )->str() );
    sendUDPString( s,si_other,&TXString); // inform the server it has to transfer a 4D dataset to zedboard 
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    cout << endl << "Waiting for incoming data..." << endl ;
    importDatasetSize(s,si_me,si_other,&bins,&trials,&channels,&stim); //receive and save dataset dimension
    bmiData.changeSize(bins,trials,channels,stim); //change size of the 'bmiData' struct according to the just received dimension
    importDataset(s,si_me,si_other, &bmiData); // fill 'bmiData' struct with the data coming from server trial by trial
  }
  
  cout << "Please enter how many trials you wanna assign to the test set ( dataset is composed by "<<bmiData.trials<<" trials) : ";
  cin >> numTestTrial; //save number of test trial
  numTrainTrial=bmiData.trials-numTestTrial; //save number of train trial
  hiddenNeurons=NEURONS-(neuronPerClass*bmiData.stim); //compute the amount of hidden neurons
  


  
  ////////////////NN training////////////////////////
  
  cout << "Do you wanna perform the NN training? [yes=1/no=0] ";
  cin >> ans;
  if(ans)
  {
    //training session
    cout << "Do you wanna perform the training on chip? [yes=1/no=0] ";
    cin >> ans;
    if(ans)
    {
    //training on neuro chip
      
      resetMN256(mn256_handle); //reset all the connection on the neurochip 
      cout<<"Initializing network..."<<endl;
      fflush(stdout);
      initMN256(stim,neuronPerClass,channels,mn256_handle); //initialize the basic structure of the neurochip
      fflush(stdout);
      matrix2Di trial(channels,bins); //prepare a 2D matrix struct that can store a single trial neural activity
      trial.clear(); //initialize the above created struct
      //training loop
      for(int j=0;j<numTrainTrial;j++)
      {
	for(int l=0;l<bmiData.stim;l++)
	{
	  for(int i=0;i<bmiData.bins;i++)
	  {
	    for(int k=0;k<bmiData.channels;k++)
	    {
 	      trial(k,i)=bmiData.data[i][j][k][l]; //extract single trial from the training dataset and copy it into single trial 2D struct
	    }
	  }
	  //train trial by trial the mn256
	  cout<<"Num Trial: "<<j+1<<"; Num stim: "<<l+1<<endl; 
 	  trainMN256(trial,l,binSizeMs,stim,mn256_handle);
          usleep(100000);
	  //maybe here we need such ms pause to let the mn256 free to evolve
	}
      }
      cout<<"Training Completed with Success!"<<endl;
    }
    else
    {
      //simulated training using python emulator functions
      
      //adapt dataset such that can be used by the python functions
      for(int l=0;l<bmiData.stim;l++)
      {
	for(int i=0;i<bmiData.trials;i++)
	{
	  for(int j=0;j<bmiData.channels;j++)
	  {
	    spikeCount=0;
	    for(int k=0;k<bmiData.bins;k++) //count how many spike are present into the considered trial
	    {
	      spikeCount=spikeCount+bmiData.data[k][i][j][l];
	    }
	    data += (static_cast<ostringstream*>( &(ostringstream() << spikeCount ) )->str() ); //convert spikeCount number into a string
	    data += ',';
	  }
	  label += (static_cast<ostringstream*>( &(ostringstream() << l ) )->str() );//convert label number into a string
	  label += ',';
	}
      }

      ////////////////////////////////////////////////////
      //create train and test set

      //set path in which are located the python function
      PyRun_SimpleString("import sys");
      PyRun_SimpleString("sys.path.append(\".\")");
      //create a poiner to the python module that you wanna call
      pName = PyString_FromString("mn256");
      PyErr_Print(); //check if such error occured during the previous operation
      //import the pointed module
      pModule = PyImport_Import(pName);
      PyErr_Print();
      pDict = PyModule_GetDict(pModule);
      PyErr_Print();
      cout<<"Creating Dataset..."<<endl;
      //create a pointer to the function that you wnna call inside the imported module
      pFuncData = PyDict_GetItemString(pDict, "createDataset");
      PyErr_Print();
      //preparing data to pass to the predefined function as python parameter
      pArgsData = Py_BuildValue ("(ssiid)",data.c_str(),label.c_str(),bmiData.channels,hiddenNeurons,(double)numTrainTrial/(double)bmiData.trials);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncData)) 
      {
	  inputMN256=PyObject_CallObject(pFuncData, pArgsData); //run python function. The python object 'inputMN256' contains train dataset and its label, test dataset and its label, weight matrix
	  
      } else 
      {
	  PyErr_Print();
      }
      
  
      if (inputMN256 != NULL) //check if the python output is correct
      {
	  cout<<"Dataset created"<<endl;
      }
      else 
      {
	cout<<"Error during dataaset generation!"<<endl;
	  PyErr_Print();
      }
      
      ////////////////////////////////////////////////////////
      //train simulated neural network

      cout<<"Training neural network..."<<endl;
      pFuncTrain = PyDict_GetItemString(pDict, "train_mn256");
      PyErr_Print();
      pArgsTrain = Py_BuildValue ("(Oii)",inputMN256,neuronPerClass,10);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncTrain)) 
      {
	  NN=PyObject_CallObject(pFuncTrain, pArgsTrain);
	  
      } 
      else 
      {
	  PyErr_Print();
      }
  
      //////////////////////////////////////////////////////
      //test NN
      cout<<"Testing neural network..."<<endl;
      pFuncTestTot = PyDict_GetItemString(pDict, "perf_mn256");
      PyErr_Print();
      pArgsTestTot = Py_BuildValue ("(OO)",NN,inputMN256);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncTestTot)) 
      {
	  PyObject_CallObject(pFuncTestTot, pArgsTestTot);
      } 
      else 
      {
	  PyErr_Print();
      }
      
      //compute gain factor
      
      cout<<"Computing gain factor..."<<endl;
      pFuncGain = PyDict_GetItemString(pDict, "compute_gain");
      PyErr_Print();
      
      if (PyCallable_Check(pFuncGain)) 
      {
	  outputGain=PyObject_CallObject(pFuncGain, pArgsTestTot);
      }
      else 
      {
	  PyErr_Print();
      }
      gainFactor=PyFloat_AS_DOUBLE(outputGain); //convert pyhton float output into a c/c++ double
      cout<< "Gain : "<<gainFactor<<endl;
      
      
      ///////////////////////////////////////////////////////
      
      //built Weight and Excitatory/Inhibitory matrices
      
      matrix2Di W(NEURONS,PLASTIC_SYN+NONPLASTIC_SYN); //prepare 2D weight matrix
      W.clear();//initialize weight matrix
      matrix2Di EI(W); //create Excitatory/Inhibitory matrix
      
      //read input weight matrix (NON plastic connection)
      cout<<"Extracting input weight matrix.."<<endl;
      pFuncInputMatrix = PyDict_GetItemString(pDict, "inputMatrix");
      PyErr_Print();
      //preparing data to be passed as python parameter
      pArgsInputMatrix = Py_BuildValue ("(O)",inputMN256);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncInputMatrix)) 
      {
	  inputWeight=PyObject_CallObject(pFuncInputMatrix, pArgsInputMatrix); //extract form the python struct 'inputMN256' the input weight matrix and save it into the python matrix 'inputWeight'
      } 
      else 
      {
	  PyErr_Print();
      }
      
      if(inputWeight != NULL)
      {
        //convert python matrix 'inputWeight' into c++ 'W' and 'EI' 2D matrices
	PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) inputWeight );  
	long* dims = (long*)obj->dimensions; // read python dimension 
	double* data = (double*) obj->data; // read data inside 'inputWeight' python matrix
	int k=0;
	// copy red data into the c++ matrix
	for( int i=0; i<dims[0]; i++ )
	{
	  for( int j=0; j<dims[1]; j++ )
	  {
	    EI(i,j+NONPLASTIC_SYN)=data[k++];
	    W(i,j+NONPLASTIC_SYN)=abs(EI(i,j+NONPLASTIC_SYN));
	  }
	}
      }
      //read output weight matrix (plastic connection)
      cout<<"Extracting output weight matrix.."<<endl;
      pFuncOutputMatrix = PyDict_GetItemString(pDict, "activityMatrix");
      PyErr_Print();
      //preparing data to pass as python parameter
      pArgsOutputMatrix = Py_BuildValue ("(O)",NN);
      PyErr_Print();
      
      if (PyCallable_Check(pFuncOutputMatrix)) 
      {
	  outputWeight=PyObject_CallObject(pFuncOutputMatrix, pArgsOutputMatrix); //extract form the python struct 'NN' the output weight matrix and save it into the python matrix 'outputWeight'
      } 
      else 
      {
	  PyErr_Print();
      }
      if(outputWeight != NULL)
      {
        //convert python matrix 'outputWeight' into c++ 'W' and 'EI' 2D matrices
	PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) outputWeight );  
	long* dims = (long*)obj->dimensions;  
	double* data = (double*) obj->data;
	int k=0;
	//copy red data into the c++ matrix
	for( int i=0; i<dims[0]; i++ )
	{
	  for( int j=0; j<dims[1]; j++ )
	  {
	    EI(i+hiddenNeurons,j)=data[k++];
	    W(i+hiddenNeurons,j)=abs(EI(i+hiddenNeurons,j));
	  }
	}
      }

      
      //reset mn256 chip
      resetMN256(mn256_handle); //reset all the connection on the neurochip 

      //send calibration data to the nm256
      configureMN256(W,EI,stim,neuronPerClass,channels,mn256_handle); //configure neuro chip according to the W,EI and structure derived from the simulated trained Neural Network
      cout<<"MN256 CONFIGURED!"<<endl;
    }
  }
  
  /*std::vector<int> outputLayer;
  readData(1000,&outputLayer, mn256_handle);
  cout<<"Output -> ";
  for(int k=0;k<outputLayer.size();k++)
  {
    cout<<" "<<outputLayer[k];
  }*/

  sensoryField SF(rangeX,rangeY,zero,bmiData.stim,sensoryResolution); //instantiate the Sensory Field object according to the predefined parameters 
  forceField motorMap(rangeX,rangeY,zero,xxstiff,yystiff,SF); //instantiate the Motor Map object according to the predefined parameters 
 
  
  
  /////////////////send sensory field and motor map to matlab client for visualization///////////////
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeX[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeX[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeY[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << rangeY[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << zero[0] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << zero[1] ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << SF.resolution ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << xxstiff ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << yystiff ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  TXString=(static_cast<ostringstream*>( &(ostringstream() << radius ) )->str() );
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  cout<<"Workspace dimension trasnmitted!"<<endl;
	
  //receiveUDPString(s,si_me,si_other,&ACKstring);
  usleep(3000000);

  int counter=0;
  for(int y=rangeY[0];y<=rangeY[1];y++)
  {
    for(int x=rangeX[0];x<=rangeX[1];x++)
    {
      counter++;
      TXString.erase();
     
      motorMap.computeForce(double(x),double(y),&Force);
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[1] ) )->str() );
      
//       printf("Upload motor map %d%%\n", counter*100/((-rangeY[0]+rangeY[1]+1)*(-rangeX[0]+rangeX[1]+1)) );
      
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    }
  }
  
  //receiveUDPString(s,si_me,si_other,&ACKstring);
  
  for (it=motorMap.meanForce.begin();it != motorMap.meanForce.end();++it)
  {
    TXString.erase();
    for(its=it->begin();its != it->end();++its)
    {
      TXString += (static_cast<ostringstream*>( &(ostringstream() << *its ) )->str() );
      TXString += ' ';
    }
     sendUDPString( s,si_other,&TXString);
     if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  }
    
  counter=0;
  for(int r=0;r<SF.map.size1();r++)
  {
    TXString.erase();
    for(int c=0;c<SF.map.size2();c++)
    {
      counter++;
      TXString += (static_cast<ostringstream*>( &(ostringstream() << SF.map(r,c) ))->str() );
      TXString += ' ';
      
//       printf("Upload sensory map %lu%%\n", counter*100/(SF.map.size1()*SF.map.size2()) );
    }
    sendUDPString( s,si_other,&TXString);
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  }
  
  ////////////////////////BMI running/////////////////////////////
  
  /* 1)decide init position
   * 2)stim the related electrode
   * 3)record the evoked activity
   * 4)run NN
   * 5)decode output into a force
   * 6)apply the force to the DS
   * 7)move the DS accordingly to the dynamics of the system
   * 8)after deltaT acquire current possition and restart from 2)
   */
  dynamicParam DS(xxmass,yymass,xxdamp,yydamp,rangeX,rangeY,zero,radius,deltaTms,interTms);
  motorHandle motorFeeder(rangeX,rangeY);
  initMotor(&motorFeeder);
  //calibration
  cout << "Do you wanna check motor? [yes=1/no=0] ";
  cin >> ans;
  if(ans==1) calibrateMotor(motorFeeder);
  
  while(ONTrial==1)
  {
    TXString="777"; //777 code define the event "start trial"
    sendUDPString( s,si_other,&TXString);
    if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    
    //set initial position
    bool pos_ok=false;
    
    //x0
    while(pos_ok==false)
    {
      cout << "\nInsert initial 'x' position ( x:["<<rangeX[0]<<","<<rangeX[1]<<"] ) -> ";
      cin >> position[0];
      if(position[0]<rangeX[0] || position[0]>rangeX[1])
      {
	cout << "x coordinate out of bounds"<<endl;
	pos_ok=false;
      }
      else
      {
	pos_ok=true;
      }
    }

    //y0
    pos_ok=false;
    while(pos_ok==false)
    {
      cout << "Insert initial 'y' position ( y:["<<rangeY[0]<<","<<rangeY[1]<<"] ) -> ";
      cin >> position[1];
      if(position[1]<rangeY[0] || position[1]>rangeY[1])
      {
	cout << "y coordinate out of bounds"<<endl;
	pos_ok=false;
      }
      else
      {
	pos_ok=true;
      }
    }
    
    moveMotor(position,motorFeeder); //move feeder into initial position
    
    //initilize to zero the initial velocity
    velocity[0]=0;
    velocity[1]=0;
    
    int currStep=0;
    bool targetReached=false;
    
    //start BMI loop
    cout << "Do you wanna use MN256 or Simulated NN? [mn256=1/simNN=0] ";
    cin >> ans;
    while(currStep<maxSteps)
    {
      //stim the related electrode
      long outputClass=-1;
      curr_region=SF.whichRegion(position[0],position[1]);
      stimElectrode=electrodeMap[curr_region];
      cout<<endl<<"timeStep: "<< currStep <<", pos:("<<position[0]<<","<<position[1]<<") -> region:"<< curr_region <<"   electrode:"<<stimElectrode<<endl<<endl;

      ////////////////////////////////////////////////Substitute with the new NN code//////////////////////////////////////////////////////////
      //select evoked activity and runBMI
      std::vector<float> outputLayer;
      outputLayer.resize(bmiData.stim);  

      
      if(ans)
      {
	matrix2Di trial(channels,bins); //prepare a 2D matrix struct that can store a single trial neural activity
        trial.clear(); //initialize the above created struct
        int curr_trial=rand() % numTestTrial;
        //training loop
	  for(int i=0;i<bmiData.bins;i++)
	  {
	    for(int k=0;k<bmiData.channels;k++)
	    {
 	      trial(k,i)=bmiData.data[i][curr_trial+numTrainTrial][k][curr_region]; //extract single trial from the test dataset and copy it into single trial 2D struct
	    }
	  }
	  //train trial by trial the mn256
	  cout<<"Num Trial: "<<curr_trial+numTrainTrial+1<<"; Num stim: "<<curr_region+1<<endl; 
 	  sendStimToNM256(trial,mn256_handle);
          //acquire time stamp
          long startRec=0; ////MODIFY WITH AN FPGA CALL///////////
          //wait
          usleep(bins*1000);

	  //record for bins ms
	  pthread_mutex_lock(&lock);
          pthread_cond_wait(&cond,&lock);
          //read from buffer
	  for(int k=0;k<MAX_BUFFER_SIZE;k++)
	  {
             //if(BUFFER[(k+bufferIdx+1)%MAX_BUFFER_SIZE]
	  }
	  //release mutex
          pthread_mutex_unlock(&lock);
	
      }
      else
      {
	pFuncTest = PyDict_GetItemString(pDict, "out_mn256");
	PyErr_Print();
	//preparing data to pass as python parameter
	pArgsTest = Py_BuildValue ("(OOi)",NN,inputMN256,curr_region);
	PyErr_Print();
	pFuncClass = PyDict_GetItemString(pDict, "classify_mn256");
	PyErr_Print();
	
	
	if (PyCallable_Check(pFuncTest) && PyCallable_Check(pFuncClass)) 
	{
	    
	    outClass=PyObject_CallObject(pFuncClass, pArgsTest);
	    outputClass=PyInt_AsLong(outClass);
	    cout<< "Stim : "<<curr_region+1 <<"  Output Class: "<<outputClass+1<<endl;
	    outActivity=PyObject_CallObject(pFuncTest, pArgsTest);
	   
	} else 
	{
	    PyErr_Print();
	}
	
	if(outActivity != NULL)
	{
	  PyArrayObject* obj = PyArray_GETCONTIGUOUS( (PyArrayObject*) outActivity );  
	  int ndims = obj->nd;
	  long* dims = (long*)obj->dimensions; // not copying data   
	  double* data = (double*) obj->data; // not copying data
	  // output vector result
	  for( int i=0; i<dims[0]; i++ )
	  {
	    outputLayer[i]=data[i];
	  }
	}
      }  
      
      cout << "Output neuron 1 : "<<outputLayer[0]<<endl;
      cout << "Output neuron 2 : "<<outputLayer[1]<<endl;
      cout << "Output neuron 3 : "<<outputLayer[2]<<endl;
      cout << "Output neuron 4 : "<<outputLayer[3]<<endl;
      
      //decode the NN output into a force
      decoder(motorMap,outputLayer,gainFactor,&Force);
      
      cout<<"Force -> ["<<Force[0]<<", "<<Force[1]<<"]"<<endl;

      //send just computed Force to the server for GUI purposes
      TXString = "888 "; //888 code define the event "Force component"
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << Force[1] ) )->str() );
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
      TXString.clear();
      
      TXString = (static_cast<ostringstream*>( &(ostringstream() << position[0] ) )->str() );
      TXString += ' ';
      TXString += (static_cast<ostringstream*>( &(ostringstream() << position[1] ) )->str() );
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
      TXString.clear();
      
      //apply force to DS
      targetReached=DynSys(DS,&position,&velocity,Force,motorFeeder,s,si_me,si_other);
      
      currStep++;
      
      if(targetReached) break;
    }
    
    if(targetReached==false)
    {
      TXString="-999"; //-999 code define the event "target NOT reached"
      sendUDPString( s,si_other,&TXString);
      if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
    }
    
    cout << "Do you wanna perform another trial? [yes=1/no=0] ";
    cin >> ONTrial;
  
  } 
  
  stopMotor(motorFeeder);
  TXString="-777"; //-777 code define the event "end of experiment"
  sendUDPString( s,si_other,&TXString);
  if(SAFE_TRANSMISSION) receiveUDPString(s,si_me,si_other,&ACKstring);
  
  
  //////////////////// END ///////////////////////////////////////
  Py_Finalize();
  end_process=TRUE;
  //close(mn256_handle);
  //close(s);
  printf("Session closed\n");
  
  
  return 0;
}









//main

int main()
{
  bufferIdx=0;
  pthread_t tr,tb;
  end_process=FALSE;

  // open nm256 chip and initialize it
  mn256_handle=open(MN256_ADDR, O_RDWR | O_SYNC);
  if(mn256_handle < 0) 
  {
     printf("Cannot open /dev/neuelab for write\n");
     return -1;
  }

  /////////////////////udp parameters/////////////////////
  
  initUDP(&si_me,&si_other,&s,IP_OTHER,PORT_OTHER,PORT_ME);
  
  ////////////////////start thread////////////////////////
  
  //pthread_create(&tr,NULL,reader,NULL);
  usleep(1000);
  pthread_create(&tb,NULL,bmi,NULL);
  
  ///////////////////join thread//////////////////////////

  pthread_join(tb,NULL);
  //pthread_join(tr,NULL);

  //////////////////finalize//////////////////////////
  close(mn256_handle);
  close(s);
  return 0;

}

