from numpy import *
import missmatch as mm
import numpy as np
import matplotlib.pyplot as plt

class InputMN256:
    xi=0
    yi=0
    xt=0
    yt=0
    w_rnc=0

def createDataset(DatasetString,labelString,channels,hiddenNeurons,train_fraction,sigma=0.4,thr=0,gain=1):
        
    #print "funzione chiamata con successo"
    print "Input: ",channels
    print "Hidden Neurons: ", hiddenNeurons
    print "Train fraction: ", train_fraction
    #print "thr", thr
    #print "gain", gain
    
    label=np.fromstring(labelString, dtype='uint8', sep=',')
    Dataset=np.fromstring(DatasetString, dtype='uint8', sep=',').reshape((label.shape[0],channels))
    Dataset=np.transpose(Dataset)

    #print "Dataset", Dataset
    #print "Dataset size", Dataset.shape
    #print "label ", label
    #print "label size", label.shape
      
    #create dataset
    xi, yi, xt, yt = mm.sample_train_test(Dataset, label , train_fraction)
    #print "xi",xi
    #print "xi shape",xi.shape
    #print "yi",yi
    #print "yi shape",yi.shape
    #print "xt",xt
    #print "xt shape",xt.shape
    #print "yt",yt
    #print "yt shape",yt.shape
    
    X=InputMN256()
    X.w_rnc = (np.random.randn(hiddenNeurons, xi.shape[0]) / sqrt(xi.shape[0])).copy()

    for r in range (0,X.w_rnc.shape[0]):
      for c in range (0,X.w_rnc.shape[1]):
	if(X.w_rnc[r,c]>=0):
	  X.w_rnc[r,c]=1
	else:
	  X.w_rnc[r,c]=-1
	  
	
	
	
	
    #for r in range (0,X.w_rnc.shape[0]):
      #for c in range (0,X.w_rnc.shape[1]):
	#if(X.w_rnc[r,c]>=-1 and X.w_rnc[r,c]<=1):
	   #X.w_rnc[r,c]=sigma * np.random.randn(1) + 3 #np.random.normal(loc=1, scale=sigma, size=1)
	   ##print 'value',X.w_rnc[r,c]
	#else:
	  #X.w_rnc[r,c]=sigma * np.random.randn(1) #np.random.normal(loc=0, scale=sigma, size=1)
	  ##print 'value',X.w_rnc[r,c]
	  
    #for r in range (0,X.w_rnc.shape[0]):
      #for c in range (0,X.w_rnc.shape[1]):
	#if(X.w_rnc[r,c]>=0.5):
	  #X.w_rnc[r,c]=3
	#elif(X.w_rnc[r,c]<0.5 and X.w_rnc[r,c]>=0):
	  #X.w_rnc[r,c]=2
	#elif(X.w_rnc[r,c]<0 and X.w_rnc[r,c]>=-0.5):
	  #X.w_rnc[r,c]=1
	#else:
	  #X.w_rnc[r,c]=0
	  

    X.xi = (np.tanh(gain * (np.dot(X.w_rnc, (xi)) - thr))).copy()
    X.xt = (np.tanh(gain * (np.dot(X.w_rnc, (xt)) - thr))).copy()
    X.yi=(yi).copy()
    X.yt=(yt).copy()
    #print "X",X.w_rnc
	
    #print "RCN projection matrix size is :", X.w_rnc.shape
    
   
    #print "xi",X.xi
    #print "xi new shape",X.xi.shape
    
    
    #print "xt",X.xt
    #print "xt new shape",X.xt.shape
    
    
    #print "yi",yi
    #print "yi new shape",X.yi.shape
    
    
    #print "yt",X.yt
    #print "yt new shape",X.yt.shape
    ##X.xt=(xt).copy()
    ##X.yt=(yt).copy()
    ##X.xi=(xi).copy()
    ##X.yi=(yi).copy()
    ###########################################################################################################################
    #NN = mm.Ensemble()
    #print 'Creato NN'
    #NN.train(X.xi, X.yi, 10, mm.Perceptron, {'n':((256-hiddenNeurons)/4)})
    
    #print NN.confusion(X.xt,X.yt)
    ##print "NN.w",NN.w
    ##print "NN.shape",NN.w.shape
    
    #perf = NN.test(X.xt, X.yt)
    #print 'Performances', perf
  
    ############################################################################################################################
    return X
  
  
  
  
def train_mn256(X,neuronsPerClass,n_epochs):

    #train NN
    NN = mm.Ensemble()
    
    #NN.train(X.xi, X.yi, n_epochs, mm.BinaryStochMismatch, code_args={'n':neuronsPerClass})
    #NN.train(X.xi, X.yi, n_epochs, mm.Perceptron, code_args={'n':neuronsPerClass})
    NN.train(X.xi, X.yi, n_epochs, mm.BinaryStoch, code_args={'n':neuronsPerClass})
    print 'Neural network trained with success!'
    #print 'The weight matrix size is : (',len(NN.w),", ",len(NN.w[0]),')'
    return NN

def perf_mn256(NN,X): 
    
    #test performances of NN
    perf = NN.test(X.xt, X.yt)
    print 'Performances: ', perf*100
    print 'Confusion Matrix: \n',NN.confusion(X.xt,X.yt)
    return perf
    
def activityMatrix(NN):
  
    A=np.matrix(NN.w)
    #print 'The weight matrix is : \n',A
    #print 'The output matrix size is :', A.shape
    #print 'The weight matrix is : \n',NN.w
    #print 'The weight matrix size is : (',len(NN.w),", ",len(NN.w[0]),')'
    return A

def inputMatrix(X):
  
    #print 'The input matrix is : \n',X.w_rnc
    #print 'The input matrix size is :',X.w_rnc.shape
    return X.w_rnc
  
def out_mn256(NN,X,region):
    
    trialPerClass=X.yt.shape[0]/(X.yt[X.yt.shape[0]-1]+1)
    tr=(np.random.random_integers(0,trialPerClass-1))
    sh=region*trialPerClass
    tr=tr+sh
    inputActivity=X.xt[:,tr]
    #print 'Trial : ',inputActivity
    outActivity=NN.activate(inputActivity)
    #print 'output:',outActivity
    num_out= int(outActivity.shape[0])
    num_bins = np.arange(num_out)
    numClass = 4
    oa=np.empty((numClass,(num_out/numClass)))
    
    for i in range(0,(num_out/numClass)):
      for j in range(0,numClass):
        oa[j,i]=outActivity[i*numClass+j]
    
    inline_oa=np.reshape(oa,num_out)
    #print 'inline_oa:',inline_oa
    
    inline_oc=[]
    mycolor='rgby'
    for i in range(0,(numClass)):
      for j in range(0,(num_out/numClass)):
	inline_oc.append(mycolor[i])
	
    marray=np.mean(oa, axis=1)
    #print 'Mean population responses: ',marray
    
    
    ####plot routine
    #f, axarr = plt.subplots(2, sharex=True)
    
    #axarr[0].bar(num_bins,inline_oa,color=inline_oc)
    #axarr[0].set_ylabel('Activity Reorganized')
    
    
    #axarr[1].bar(num_bins,outActivity)
    #axarr[1].set_ylabel('Activity Original')
    #axarr[1].set_xlabel('neuron number')
    
    #plt.show()
    
    return marray
  
def classify_mn256(NN,X,region):
  
    #print 'size yt',X.yt.shape[0]
    #print 'last element',(X.yt[X.yt.shape[0]-1])
    trialPerClass=X.yt.shape[0]/(X.yt[X.yt.shape[0]-1]+1)
    #print 'trialPerClass',trialPerClass
    #print 'label : ',X.yt
    tr=(np.random.random_integers(0,trialPerClass-1))
    #print 'random int',tr
    sh=region*trialPerClass
    #print 'sh',sh
    tr=tr+sh
    #print 'trial random index : ',tr
    inputActivity=X.xt[:,tr]
    #print 'Trial : ',inputActivity
    label=NN(inputActivity)
    #print 'Class: ',label
    return label
  
    
def compute_gain(NN,X):
  
    #print 'numel in xi',X.xi.shape[1]
    gain=-1
    
    for i in range(0,(X.xi.shape[1])):
	inputActivity=X.xi[:,i]
	outActivity=NN.activate(inputActivity)
	
	num_out= int(outActivity.shape[0])
	num_bins = np.arange(num_out)
	numClass = 4
	oa=np.empty((numClass,(num_out/numClass)))
	
	for i in range(0,(num_out/numClass)):
	  for j in range(0,numClass):
	    oa[j,i]=outActivity[i*numClass+j]
	
	inline_oa=np.reshape(oa,num_out)
	marray=np.mean(oa, axis=1)
	tempmax=np.amax(marray);
	#print 'tempmax',tempmax
	
	if tempmax > gain:	  
	  gain=tempmax
	  

    return gain
  
