%% Define computer-specific variables
close all
clear all
abort_transmission=false;
% Modify these values to be those of your second computer (Transmitter):
ipR = '10.255.37.113'; portR = 9103;   
% Modify these values to be those of your first computer (Receiver):
portT = 9095;  
%enable echo
% echoudp('on',portS)

%% Create UDP Object
udpR = udp(ipR,portR,'LocalPort',portT);
%% Connect to UDP Object
fopen(udpR);
disp('Connection established');
%% Transmitting phase
disp('Ready to receive');
while(abort_transmission==false)
    while(udpR.BytesAvailable==0)
        pause(0.1);
    end
    size_data=udpR.BytesAvailable;
    [data,count,msg,datagramaddress,datagramport]=fscanf(udpR);
    disp(['Data received ',datagramaddress,':',num2str(portR),': ',data,' (',num2str(size_data),'B)']);
    if(strcmp(data,'quit')==1)
        abort_transmission=true;
    end
end

%% Quit phase
disp('Session closed');
fclose(udpR);
delete(udpR);
clear udpR;