function varargout = mn256Viewer(varargin)
% MN256VIEWER MATLAB code for mn256Viewer.fig
%      MN256VIEWER, by itself, creates a new MN256VIEWER or raises the existing
%      singleton*.
%
%      H = MN256VIEWER returns the handle to a new MN256VIEWER or the handle to
%      the existing singleton*.
%
%      MN256VIEWER('CALLBACK',hObject,eventData,handles,...) calls the local
%      function named CALLBACK in MN256VIEWER.M with the given input arguments.
%
%      MN256VIEWER('Property','Value',...) creates a new MN256VIEWER or raises the
%      existing singleton*.  Starting from the left, property value pairs are
%      applied to the GUI before mn256Viewer_OpeningFcn gets called.  An
%      unrecognized property name or invalid value makes property application
%      stop.  All inputs are passed to mn256Viewer_OpeningFcn via varargin.
%
%      *See GUI Options on GUIDE's Tools menu.  Choose "GUI allows only one
%      instance to run (singleton)".
%
% See also: GUIDE, GUIDATA, GUIHANDLES

% Edit the above text to modify the response to help mn256Viewer

% Last Modified by GUIDE v2.5 14-May-2015 16:13:00

% Begin initialization code - DO NOT EDIT
gui_Singleton = 1;
gui_State = struct('gui_Name',       mfilename, ...
    'gui_Singleton',  gui_Singleton, ...
    'gui_OpeningFcn', @mn256Viewer_OpeningFcn, ...
    'gui_OutputFcn',  @mn256Viewer_OutputFcn, ...
    'gui_LayoutFcn',  [] , ...
    'gui_Callback',   []);
if nargin && ischar(varargin{1})
    gui_State.gui_Callback = str2func(varargin{1});
end

if nargout
    [varargout{1:nargout}] = gui_mainfcn(gui_State, varargin{:});
else
    gui_mainfcn(gui_State, varargin{:});
end
% End initialization code - DO NOT EDIT


% --- Executes just before mn256Viewer is made visible.
function mn256Viewer_OpeningFcn(hObject, eventdata, handles, varargin)
% This function has no output args, see OutputFcn.
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% varargin   command line arguments to mn256Viewer (see VARARGIN)

% Choose default command line output for mn256Viewer
handles.output = hObject;
% Modify these values to be those of your second computer (Transmitter):
ipR = '10.255.37.51'; portR = 9103;
% Modify these values to be those of your first computer (Receiver):
portT = 9103;

%%Create UDP Object
handles.udpR = udp(ipR,portR,'LocalPort',portT,'InputBufferSize',65535,'OutputBufferSize',65535,'OutputDatagramPacketSize',65535,'InputDatagramPacketSize',512);
%%Connect to UDP Object
fopen(handles.udpR);
disp('Connection established');
disp('Ready to receive');
%%initialize parameters
handles.lowOut=0; %total number of ch
handles.highOut=255; %total number of ch
handles.lastXVal=0; %last time value
handles.windowsSize=5; %window size in seconds
handles.delta=.2; %refresh time in second of the time axis
handles.quit=false;
handles.maxChannels=255;


axes(handles.axesViewer);
handles.h = animatedline('MaximumNumPoints',1000000,'LineStyle','none','Marker','.','MarkerSize',20);%,'parent',handles.axesViewer);
% handles.h.UIContextMenu = handles.axesViewer;
axis([handles.lastXVal,handles.lastXVal+handles.windowsSize,handles.lowOut+0.5,handles.highOut+0.5]);


% Update handles structure
guidata(hObject, handles);

% UIWAIT makes mn256Viewer wait for user response (see UIRESUME)
% uiwait(handles.figure1);


% --- Outputs from this function are returned to the command line.
function varargout = mn256Viewer_OutputFcn(hObject, eventdata, handles)
% varargout  cell array for returning output args (see VARARGOUT);
% hObject    handle to figure
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Get default command line output from handles structure
varargout{1} = handles.output;



function editWinSize_Callback(hObject, eventdata, handles)
% hObject    handle to editWinSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editWinSize as text
%        str2double(get(hObject,'String')) returns contents of editWinSize as a double
tmpWin=str2num(get(hObject,'String'));

if(tmpWin<=0)
    errordlg('Value not Allowed');
    set(hObject,'String',num2str(handles.windowsSize));
else
    handles.windowsSize=tmpWin;
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function editWinSize_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editWinSize (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Update handles structure
guidata(hObject, handles);



function editUpOut_Callback(hObject, eventdata, handles)
% hObject    handle to editUpOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editUpOut as text
%        str2double(get(hObject,'String')) returns contents of editUpOut as a double
tmpHigh=str2num(get(hObject,'String'));

if(tmpHigh<=handles.lowOut || tmpHigh>handles.maxChannels)
    errordlg('Value not Allowed');
    set(hObject,'String',num2str(handles.highOut));
else
    handles.highOut=tmpHigh;
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function editUpOut_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editUpOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Update handles structure
guidata(hObject, handles);



function editLowOut_Callback(hObject, eventdata, handles)
% hObject    handle to editLowOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editLowOut as text
%        str2double(get(hObject,'String')) returns contents of editLowOut as a double
tmpLow=str2num(get(hObject,'String'));

if(tmpLow>=handles.highOut || tmpLow<0)
    errordlg('Value not Allowed');
    set(hObject,'String',num2str(handles.lowOut));
else
    handles.lowOut=tmpLow;
end
% Update handles structure
guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function editLowOut_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editLowOut (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Update handles structure
guidata(hObject, handles);


function editRefTime_Callback(hObject, eventdata, handles)
% hObject    handle to editRefTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

% Hints: get(hObject,'String') returns contents of editRefTime as text
%        str2double(get(hObject,'String')) returns contents of editRefTime as a double
% Update handles structure
tmpRT=str2num(get(hObject,'String'));

if(tmpRT<0 || tmpRT>handles.windowsSize)
    errordlg('Value not Allowed');
    set(hObject,'String',num2str(handles.delta));
else
    handles.delta=tmpRT;
end

guidata(hObject, handles);

% --- Executes during object creation, after setting all properties.
function editRefTime_CreateFcn(hObject, eventdata, handles)
% hObject    handle to editRefTime (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    empty - handles not created until after all CreateFcns called

% Hint: edit controls usually have a white background on Windows.
%       See ISPC and COMPUTER.
if ispc && isequal(get(hObject,'BackgroundColor'), get(0,'defaultUicontrolBackgroundColor'))
    set(hObject,'BackgroundColor','white');
end
% Update handles structure
guidata(hObject, handles);

% --- Executes on button press in pushbuttonQuit.
function pushbuttonQuit_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonQuit (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
% selection = questdlg('Stop the Viewer?',...
%     'Close Request Function',...
%     'Yes','No','Yes');
% switch selection,
%     case 'Yes',
handles.quit=true;
fprintf(handles.udpR,'Viewer Closed!');
pause(1);
while(handles.udpR.BytesAvailable>0) %empty rx udp fifo
    thrash=fscanf(handles.udpR);
end
disp('Viewer stopped!');
%     case 'No'
%         handles.quit=false;
%         return
% end
% Update handles structure
guidata(hObject, handles);


% --- Executes on button press in pushbuttonStart.
function pushbuttonStart_Callback(hObject, eventdata, handles)
% hObject    handle to pushbuttonStart (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)
disp('Viewer started!');
clearpoints(handles.h);
%%start viewer
while(handles.udpR.BytesAvailable==0 && handles.quit==false)
    pause(0.1);
end
%%initiliaze viewer
[data]=str2num(fscanf(handles.udpR));
x=data(1:2:end-1);
y=data(2:2:end);
t=min(x); %initial time
offset=t;
lastXVal=t; %last time value
axes(handles.axesViewer);

start=tic;
while(handles.quit==false)
    handles=guidata(hObject);
    t=max(x) %toc(start)+offset;
    idx=find(x<t);
    if(t>lastXVal+handles.windowsSize)
        lastXVal=lastXVal+handles.delta;
    end
    axis([lastXVal,lastXVal+handles.windowsSize,handles.lowOut+.5,handles.highOut+.5]);
    addpoints(handles.h,x(idx),y(idx));
    drawnow

     if(handles.udpR.BytesAvailable>0)
        nx=[];
        ny=[];
       % while(handles.udpR.BytesAvailable>0)
            data=str2num(fscanf(handles.udpR));
            nx=[nx,data(1:2:end-1)];
            ny=[ny,data(2:2:end)];
        %end
        
        %concatenate with old data
        x=[x(max(idx):end),nx];
        y=[y(max(idx):end),ny];
     end
    
    
end

guidata(hObject, handles);
handles.quit=false;
%close all;
% Update handles structure
guidata(hObject, handles);


% --- Executes when user attempts to close figure1.
function figure1_CloseRequestFcn(hObject, eventdata, handles)
% hObject    handle to figure1 (see GCBO)
% eventdata  reserved - to be defined in a future version of MATLAB
% handles    structure with handles and user data (see GUIDATA)

selection = questdlg('Quit the application?',...
    'Close Request Function',...
    'Yes','No','Yes');
switch selection,
    case 'Yes',
        clear handles.h;
        disp('Session closed');
        fclose(handles.udpR);
        delete(handles.udpR);
        clear handles.udpR;
    case 'No'
        
        return
end

% Hint: delete(hObject) closes the figure
delete(hObject);
