%% Define computer-specific variables

% Modify these values to be those of your first computer (Transmitter):
portT = 9101;   
% Modify these values to be those of your second computer (Receiver):
ipR = '10.255.37.203';  portR = 9105;  

%% Create UDP Object
udpT = udp(ipR,portR,'LocalPort',portT,'InputBufferSize',65535,'OutputBufferSize',65535,'OutputDatagramPacketSize',65535,'InputDatagramPacketSize',65535);
%% Connect to UDP Object
fopen(udpT);
disp('Connection established');
%% Transmitting phase
disp('Ready to transmit');


firingRate=255;
t=0;
onViewer=true;
elapsedTime=0;
offset=0;
nChans=255;

start=tic;
while(onViewer)
 elapsedTime=toc(start);
  T=.1;
%  T=rand(1,1);  
 while(t<T+elapsedTime)
     t=toc(start);
     %pause(.1);
 end
 
% ramp
 x=elapsedTime+offset+T.*[0:T/nChans:T-T/nChans];
 y=[1:1:nChans];
% stripes
% x=elapsedTime+offset+T.*ones(1,nChans);
% y=[1:1:nChans];
%random
%  x=elapsedTime+offset+T.*rand(1,firingRate);
%  y=round(1+nChans.*rand(1,firingRate));
 data=reshape([x;y],1,2*numel(x));
 fprintf(udpT,num2str(data));
 disp(num2str(max(x)));
 
 if(udpT.BytesAvailable>0)
     disp((fscanf(udpT)));
     onViewer=false;
 end
 
end
%% Quit phase
disp('Session closed');
fclose(udpT);
delete(udpT);
clear udpT;